﻿define(function (require,module,exports) {
    // 基于准备好的dom，初始化echarts实例
    var myRadar = echarts.init(document.getElementById('radar-container'))
        ,myBubble = echarts.init(document.getElementById('bubble-container'));

    var radarData = {
        "status" : true,
        "errorCode" : "",
        "errorMessage" : "",
        "detail" : {
            "dimensions" : [ "购买体验", "价格", "外观" ],
            "productAnalyzeDtos" : [
                {
                    "name" : "九牧",
                    "scores" : [ 2.0, 1.71, 0.0 ]
                }, {
                    "name" : "竞品1",
                    "scores" : [ 1.0, 0.0, 0.0 ]
                }, {
                    "name" : "竞品2",
                    "scores" : [ 1.0, 0.0, 0.0 ]
                }, {
                    "name" : "竞品3",
                    "scores" : [ 1.0, 0.0, 0.0 ]
                }
            ]
        }
    };
    var bubbleData = {
        "status" : true,
        "errorCode" : "",
        "errorMessage" : "",
        "detail" : [
            {name:'九牧',scroes:[4.5,6.6]},
            {name:'竞品1',scroes:[5.5,3.6]},
            {name:'竞品2',scroes:[7.5,8.6]},
            {name:'竞品3',scroes:[2.5,4.6]}
        ]
    };
    var radarOption = dataReset_radar(radarData);
    var bubbleOption = dataReset_bubble(bubbleData);

    // 使用刚指定的配置项和数据显示图表。
    myRadar.setOption(radarOption);
    myBubble.setOption(bubbleOption);
});
/*雷达图*/
var dataReset_radar = function(data){
    var data = data.detail
        ,eachData = data.productAnalyzeDtos//图例,产品类目;指标
        ,mapNav = data.dimensions
        ,option = {}
        ,title = {'text':'图标分析'}
        ,legend = {}
        ,legendData = []
        ,radar = []
        ,indicator = []
        ,series = []
        ,seriesData = [];
    if(eachData.length > 0){
        legend.data = [];  //声明图例
        for(var _eachData=0;_eachData<eachData.length;_eachData++){
            /*图表中的图例*/
            legendData.push(eachData[_eachData].name);
            /*填充数据模板*/
            seriesData.push({
                value: eachData[_eachData].scores,
                name: eachData[_eachData].name,
                symbol: 'rect',  //绘制纬度时的连接点的形状
                symbolSize: 5,  //绘制纬度时的连接点的大小
                lineStyle: {
                    normal: {
                        type: 'dashed'  //绘制纬度的线条样式
                    }
                },
                areaStyle: {
                    normal: {
                        color: 'rgba(25, 255, 255, 0.5)' //绘制出的纬度区域内的背景色
                    }
                }
            })
        }

    }else{
        console.log('productAnalyzeDtos:后台并没有返回结果！');
    }
    $.extend(legend,{
        top:30,
        left:0,
        data:legendData
    });
    if(mapNav.length>0){
        for(var _mapNav in mapNav){
            indicator.push({'text':mapNav[_mapNav]})
        }
    }else{
        console.log('dimensions:后台并没有返回结果');
    }

    /*雷达图属性配置*/
    radar.push({
        indicator:indicator,
        center: ['50%', '60%'],  //图表在页面中的位置
        radius: 90,  //图表的半径
        startAngle: 90,  //x正半轴逆时针旋转的角度（纬度1）
        splitNumber: 4,  //雷达图被分隔的数量（被多少个圆划分）
        shape: 'circle',  //雷达图背景的形状
        name: {
            formatter:'【{value}】',  //数据绑定：indicator
            textStyle: {
                color:'#72ACD1'  //纬度名称的字体颜色
            }
        },
        splitArea: {
            areaStyle: {
                color: ['rgba(114, 172, 209, 0.2)',  //纬度对应的雷达背景色；分隔数量比纬度多时，背景色随对象下标顺序指定的颜色扩散
                    'rgba(114, 172, 209, 0.4)',
                    'rgba(114, 172, 209, 0.6)',
                    'rgba(114, 172, 209, 0.8)',
                    'rgba(114, 172, 209, 1)'],
                shadowColor: 'rgba(0, 0, 0, 0.3)',  //轮廓阴影颜色
                shadowBlur: 10  //轮廓阴影厚度
            }
        },
        axisLine: {
            lineStyle: {
                color: 'rgba(255, 255, 255, 0.5)'  //圆心发出指向各纬度的半径的线条颜色
            }
        },
        splitLine: {
            lineStyle: {
                color: 'rgba(255, 255, 255, 0.5)'  //各纬度的边框颜色
            }
        }
    });
    /*雷达图数据配置*/
    series.push({
        name: '雷达图',
        type: 'radar',  //对应的图标类型
        itemStyle: {
            emphasis: {
                // color: 各异,
                lineStyle: {
                    width: 4  //focus时线条的厚度
                }
            }
        },
        data: seriesData
    });

    option.title = title;
    option.legend = legend;
    option.radar = radar;
    option.series = series;
    return option;
    ///*数据模板*/
    //var option = {
    //    title: {
    //        text: '图标结果'  //要显示的图表名称
    //    },
    //    legend: {
    //        data: ['图一','图二', '张三', '李四']  //图例，对应数据模板中的data
    //    },
    //    radar: [
    //        //雷达图属性配置
    //        {
    //            //纬度名称
    //            indicator: [
    //                { text: '指标一' },
    //                { text: '指标二' },
    //                { text: '指标三' },
    //                { text: '指标四' },
    //                { text: '指标五' }
    //            ],
    //            center: ['20%', '50%'],  //图表在页面中的位置
    //            radius: 90,  //图表的半径
    //            startAngle: 90,  //x正半轴逆时针旋转的角度（纬度1）
    //            splitNumber: 4,  //雷达图被分隔的数量（被多少个圆划分）
    //            shape: 'circle',  //雷达图背景的形状
    //            name: {
    //                formatter:'【{value}】',  //数据绑定：indicator
    //                textStyle: {
    //                    color:'#72ACD1'  //纬度名称的字体颜色
    //                }
    //            },
    //            splitArea: {
    //                areaStyle: {
    //                    color: ['rgba(114, 172, 209, 0.2)',  //纬度对应的雷达背景色；分隔数量比纬度多时，背景色随对象下标顺序指定的颜色扩散
    //                        'rgba(114, 172, 209, 0.4)',
    //                        'rgba(114, 172, 209, 0.6)',
    //                        'rgba(114, 172, 209, 0.8)',
    //                        'rgba(114, 172, 209, 1)'],
    //                    shadowColor: 'rgba(0, 0, 0, 0.3)',  //轮廓阴影颜色
    //                    shadowBlur: 10  //轮廓阴影厚度
    //                }
    //            },
    //            axisLine: {
    //                lineStyle: {
    //                    color: 'rgba(255, 255, 255, 0.5)'  //圆心发出指向各纬度的半径的线条颜色
    //                }
    //            },
    //            splitLine: {
    //                lineStyle: {
    //                    color: 'rgba(255, 255, 255, 0.5)'  //各纬度的边框颜色
    //                }
    //            }
    //        }
    //    ],
    //    series: [
    //        {
    //            name: '雷达图',
    //            type: 'radar',  //对应的图标类型
    //            itemStyle: {
    //                emphasis: {
    //                    // color: 各异,
    //                    lineStyle: {
    //                        width: 4  //focus时线条的厚度
    //                    }
    //                }
    //            },
    //            //数据模板
    //            data: [
    //                {
    //                    value: [100, 8, 0.40, -80, 2000],  //各纬度对应的指标值
    //                    name: '图一',
    //                    symbol: 'rect',  //绘制纬度时的连接点的形状
    //                    symbolSize: 5,  //绘制纬度时的连接点的大小
    //                    lineStyle: {
    //                        normal: {
    //                            type: 'dashed'  //绘制纬度的线条样式
    //                        }
    //                    },
    //                    areaStyle: {
    //                        normal: {
    //                            color: 'rgba(25, 255, 255, 0.5)' //绘制出的纬度区域内的背景色
    //                        }
    //                    }
    //                }
    //            ]
    //        }
    //    ]
    //};
    //

};
/*气泡图*/
var dataReset_bubble = function (data) {
    /*后台已经固定了4个维度，不会做更改*/
    var data = data.detail
        ,jomoo = [],product1 = [],product2 = [],product3 = []
        ,schema = [
            {name:'SCXYL',index:0,text:'市场吸引力'},
            {name:'CPJZL',index:1,text:'产品吸引力'}
        ]
        ,itemStyle = {
            normal: {
                opacity: 0.9,
                shadowBlur: 10,
                shadowBlur: 10,
                shadowOffsetX: 0,
                shadowOffsetY: 0,
                shadowColor: 'rgba(255, 255, 2555, 0.5)'
            }
        };

    /*遍历数据*/
    console.log('===',data);
    if(data.length>0){
        for(var arr in data){
            /*获取scroes，将index[0]与index[1]之和推入scroes末尾，并返回新的scroes*/
            var item = data[arr].scroes;
            item.map(function(value,index,array){
                if(index>0)return;
                return item.push(array[0]+array[1])
            });

            /*将scroes推入指定的数据模板*/
            arr==0?jomoo.push(item):
                arr==1?product1.push(item):
                    arr==2?product2.push(item):
                        arr==3?product3.push(item):
                            console.log('异常！',item,jomoo,product1,product2,product3);
        }

    }else{
        console.log('后台没有返回与产品竞争力和市场吸引力的数据!')
    }

    var option = {
            backgroundColor: 'rgba(255,255,255,0)',
            color: [
                '#fff', '#fec42c','#dd4444','#2ca3dd'
            ],
            legend: {
                y: 'top',
                data: ['九牧','竞品1', '竞品2','竞品3'],
                textStyle: {
                    color: '#231815',
                    fontSize: 16
                }
            },
            grid: {
                x: '15%',
                x2: '15%',
                y: '20%',
                y2: '17%'
            },
            tooltip: {
                padding: 10,
                backgroundColor: '#222',
                borderColor: '#777',
                borderWidth: 1,
                formatter: function (obj) {
                    var value = obj.value;
                    return schema[0].text + '：' + value[0] + '<br>'
                        +schema[1].text + '：' + value[1] + '<br>';
                }
            },
            xAxis: {
                type: 'value',
                name: '产品竞争力',
                nameGap: 30,
                nameLocation:'middle',
                nameTextStyle: {
                    color: '#231815',
                    fontSize: 14
                },
                max: 10,
                splitLine: {
                    show: false
                },
                splitNumber:5,
                axisLine: {
                    lineStyle: {
                        color: '#707070'
                    }
                }
            },
            yAxis: {
                type: 'value',
                name: '市场吸引力',
                nameLocation: 'middle',
                nameGap: 25,
                nameTextStyle: {
                    color: '#231815',
                    fontSize: 14
                },
                max:10,
                axisLine: {
                    lineStyle: {
                        color: '#707070'
                    }
                },
                splitLine: {
                    show: false
                }
            },
            visualMap: [
                {
                    show:false,
                    left: 'right',
                    top: '10%',
                    dimension: 2,
                    min: 0,
                    max: 20,
                    itemWidth: 30,
                    itemHeight: 120,
                    calculable: true,
                    precision: 0.1,
                    text: ['圆形大小：PM2.5'],
                    textGap: 30,
                    textStyle: {
                        color: '#fff'
                    },
                    inRange: {
                        symbolSize: [10, 70],
                        colorLightness: [1, .5]
                    },
                    outOfRange: {
                        symbolSize: [10, 70],
                        color: ['rgba(255,255,255,.2)']
                    }
                }
            ],
            series: [
                {
                    name: '九牧',
                    type: 'scatter',
                    itemStyle: itemStyle,
                    data: jomoo
                },
                {
                    name: '竞品1',
                    type: 'scatter',
                    itemStyle: itemStyle,
                    data: product1
                },
                {
                    name: '竞品2',
                    type: 'scatter',
                    itemStyle: itemStyle,
                    data: product2
                },
                {
                    name: '竞品3',
                    type: 'scatter',
                    itemStyle: itemStyle,
                    data: product3
                }
            ]
        };

    return option;

    /*原始的数据模板*/
    /*气泡维度*/
    //var dataBJ = [
    //    [1,55,9,56,0.46,18,6,"良"],
    //    [2,25,11,21,0.65,34,9,"优"],
    //    [3,56,7,63,0.3,14,5,"良"],
    //    [4,33,7,29,0.33,16,6,"优"],
    //    [5,42,24,44,0.76,40,16,"优"],
    //    [6,82,58,90,1.77,68,33,"良"],
    //    [7,74,49,77,1.46,48,27,"良"],
    //    [8,78,55,80,1.29,59,29,"良"],
    //    [9,267,216,280,4.8,108,64,"重度污染"],
    //    [10,185,127,216,2.52,61,27,"中度污染"],
    //    [11,39,19,38,0.57,31,15,"优"],
    //    [12,41,11,40,0.43,21,7,"优"],
    //    [13,64,38,74,1.04,46,22,"良"],
    //    [14,108,79,120,1.7,75,41,"轻度污染"],
    //    [15,108,63,116,1.48,44,26,"轻度污染"],
    //    [16,33,6,29,0.34,13,5,"优"],
    //    [17,94,66,110,1.54,62,31,"良"],
    //    [18,186,142,192,3.88,93,79,"中度污染"],
    //    [19,57,31,54,0.96,32,14,"良"],
    //    [20,22,8,17,0.48,23,10,"优"],
    //    [21,39,15,36,0.61,29,13,"优"],
    //    [22,94,69,114,2.08,73,39,"良"],
    //    [23,99,73,110,2.43,76,48,"良"],
    //    [24,31,12,30,0.5,32,16,"优"],
    //    [25,42,27,43,1,53,22,"优"],
    //    [26,154,117,157,3.05,92,58,"中度污染"],
    //    [27,234,185,230,4.09,123,69,"重度污染"],
    //    [28,160,120,186,2.77,91,50,"中度污染"],
    //    [29,134,96,165,2.76,83,41,"轻度污染"],
    //    [30,52,24,60,1.03,50,21,"良"],
    //    [31,46,5,49,0.28,10,6,"优"]
    //];
    //var dataGZ = [
    //    [1,26,37,27,1.163,27,13,"优"],
    //    [2,85,62,71,1.195,60,8,"良"],
    //    [3,78,38,74,1.363,37,7,"良"],
    //    [4,21,21,36,0.634,40,9,"优"],
    //    [5,41,42,46,0.915,81,13,"优"],
    //    [6,56,52,69,1.067,92,16,"良"],
    //    [7,64,30,28,0.924,51,2,"良"],
    //    [8,55,48,74,1.236,75,26,"良"],
    //    [9,76,85,113,1.237,114,27,"良"],
    //    [10,91,81,104,1.041,56,40,"良"],
    //    [11,84,39,60,0.964,25,11,"良"],
    //    [12,64,51,101,0.862,58,23,"良"],
    //    [13,70,69,120,1.198,65,36,"良"],
    //    [14,77,105,178,2.549,64,16,"良"],
    //    [15,109,68,87,0.996,74,29,"轻度污染"],
    //    [16,73,68,97,0.905,51,34,"良"],
    //    [17,54,27,47,0.592,53,12,"良"],
    //    [18,51,61,97,0.811,65,19,"良"],
    //    [19,91,71,121,1.374,43,18,"良"],
    //    [20,73,102,182,2.787,44,19,"良"],
    //    [21,73,50,76,0.717,31,20,"良"],
    //    [22,84,94,140,2.238,68,18,"良"],
    //    [23,93,77,104,1.165,53,7,"良"],
    //    [24,99,130,227,3.97,55,15,"良"],
    //    [25,146,84,139,1.094,40,17,"轻度污染"],
    //    [26,113,108,137,1.481,48,15,"轻度污染"],
    //    [27,81,48,62,1.619,26,3,"良"],
    //    [28,56,48,68,1.336,37,9,"良"],
    //    [29,82,92,174,3.29,0,13,"良"],
    //    [30,106,116,188,3.628,101,16,"轻度污染"],
    //    [31,118,50,0,1.383,76,11,"轻度污染"]
    //];
    //var dataSH = [
    //    [1,91,45,125,0.82,34,23,"良"],
    //    [2,65,27,78,0.86,45,29,"良"],
    //    [3,83,60,84,1.09,73,27,"良"],
    //    [4,109,81,121,1.28,68,51,"轻度污染"],
    //    [5,106,77,114,1.07,55,51,"轻度污染"],
    //    [6,109,81,121,1.28,68,51,"轻度污染"],
    //    [7,106,77,114,1.07,55,51,"轻度污染"],
    //    [8,89,65,78,0.86,51,26,"良"],
    //    [9,53,33,47,0.64,50,17,"良"],
    //    [10,80,55,80,1.01,75,24,"良"],
    //    [11,117,81,124,1.03,45,24,"轻度污染"],
    //    [12,99,71,142,1.1,62,42,"良"],
    //    [13,95,69,130,1.28,74,50,"良"],
    //    [14,116,87,131,1.47,84,40,"轻度污染"],
    //    [15,108,80,121,1.3,85,37,"轻度污染"],
    //    [16,134,83,167,1.16,57,43,"轻度污染"],
    //    [17,79,43,107,1.05,59,37,"良"],
    //    [18,71,46,89,0.86,64,25,"良"],
    //    [19,97,71,113,1.17,88,31,"良"],
    //    [20,84,57,91,0.85,55,31,"良"],
    //    [21,87,63,101,0.9,56,41,"良"],
    //    [22,104,77,119,1.09,73,48,"轻度污染"],
    //    [23,87,62,100,1,72,28,"良"],
    //    [24,168,128,172,1.49,97,56,"中度污染"],
    //    [25,65,45,51,0.74,39,17,"良"],
    //    [26,39,24,38,0.61,47,17,"优"],
    //    [27,39,24,39,0.59,50,19,"优"],
    //    [28,93,68,96,1.05,79,29,"良"],
    //    [29,188,143,197,1.66,99,51,"中度污染"],
    //    [30,174,131,174,1.55,108,50,"中度污染"],
    //    [31,187,143,201,1.39,89,53,"中度污染"]
    //];
    ///*tooltip提示中的数据模板，移动端可以移除*/
    //var schema = [
    //    {name: 'date', index: 0, text: '日'},
    //    {name: 'AQIindex', index: 1, text: 'AQI指数'},
    //    {name: 'PM25', index: 2, text: 'PM2.5'},
    //    {name: 'PM10', index: 3, text: 'PM10'},
    //    {name: 'CO', index: 4, text: '一氧化碳（CO）'},
    //    {name: 'NO2', index: 5, text: '二氧化氮（NO2）'},
    //    {name: 'SO2', index: 6, text: '二氧化硫（SO2）'}
    //];
    ///*气泡的全局配置*/
    //var itemStyle = {
    //    normal: {
    //        opacity: 0.8,//气泡的透明度
    //        shadowBlur: 10,//气泡的阴影厚度
    //        shadowOffsetX: 0,//气泡阴影的x轴偏移
    //        shadowOffsetY: 0,//气泡阴影的y轴偏移
    //        shadowColor: 'rgba(0, 0, 0, 0.5)'//气泡的阴影色
    //    }
    //};
    ///*气泡模板配置*/
    //var bubbleData = {
    //    backgroundColor: '#404a59',//气泡图背景色
    //    color: [
    //        '#dd4444', '#fec42c', '#80F1BE'//维度对应的背景色；维度多余设置的背景色时，背景色随对象下标顺序指定的颜色交替
    //    ],
    //    legend: {
    //        y: 'top',//图例显示的位置
    //        data: ['北京', '上海', '广州'],//图例所示的维度名称
    //        textStyle: {
    //            color: '#fff',//图例所示的维度名称的字体颜色
    //            fontSize: 16//图例所示的维度名称的字体大小
    //        }
    //    },
    //    grid: {
    //        x: '10%',//绘图坐标左上角x轴偏移
    //        x2: '20%',//绘图坐标右下角x轴偏移
    //        y: '15%',//绘图坐标左上角y轴偏移
    //        y2: '10%'//绘图坐标右下角y轴偏移
    //    },
    //    tooltip: {
    //        padding: 10,
    //        backgroundColor: '#222',
    //        borderColor: '#777',
    //        borderWidth: 1,
    //        formatter: function (obj) {
    //            var value = obj.value;
    //            return '<div style="border-bottom: 1px solid rgba(255,255,255,.3); font-size: 18px;padding-bottom: 7px;margin-bottom: 7px">'
    //                + obj.seriesName + ' ' + value[0] + '日：'
    //                + value[7]
    //                + '</div>'
    //                + schema[1].text + '：' + value[1] + '<br>'
    //                + schema[2].text + '：' + value[2] + '<br>'
    //                + schema[3].text + '：' + value[3] + '<br>'
    //                + schema[4].text + '：' + value[4] + '<br>'
    //                + schema[5].text + '：' + value[5] + '<br>'
    //                + schema[6].text + '：' + value[6] + '<br>';
    //        }
    //    },
    //    xAxis: {
    //        type: 'value',
    //        name: '日期',//坐标x轴名称
    //        nameGap: 16,//名称距离x轴终点的距离
    //        nameTextStyle: {
    //            color: '#fff',//名称字体颜色
    //            fontSize: 14//名称字体大小
    //        },
    //        max: 31,//x轴最大值
    //        splitLine: {
    //            show: false//是否显示x轴上的分隔线
    //        },
    //        axisLine: {
    //            lineStyle: {
    //                color: '#eee'//x轴的线条颜色
    //            }
    //        }
    //    },
    //    yAxis: {
    //        type: 'value',
    //        name: 'AQI指数',
    //        nameLocation: 'end',//y轴名称显示的位置
    //        nameGap: 20,
    //        nameTextStyle: {
    //            color: '#fff',
    //            fontSize: 16
    //        },
    //        axisLine: {
    //            lineStyle: {
    //                color: '#eee'
    //            }
    //        },
    //        splitLine: {
    //            show: false
    //        }
    //    },
    //    /*屏幕尺寸所限，不展示游标尺度*/
    //    visualMap: [
    //        {
    //            left: 'right',
    //            top: '10%',
    //            dimension: 2,
    //            min: 0,
    //            max: 250,
    //            itemWidth: 30,
    //            itemHeight: 120,
    //            calculable: true,
    //            precision: 0.1,
    //            text: ['圆形大小：PM2.5'],
    //            textGap: 30,
    //            textStyle: {
    //                color: '#fff'
    //            },
    //            inRange: {
    //                symbolSize: [10, 70]
    //            },
    //            outOfRange: {
    //                symbolSize: [10, 70],
    //                color: ['rgba(255,255,255,.2)']
    //            },
    //            controller: {
    //                inRange: {
    //                    color: ['#c23531']
    //                },
    //                outOfRange: {
    //                    color: ['#444']
    //                }
    //            }
    //        },
    //        {
    //            left: 'right',
    //            bottom: '5%',
    //            dimension: 6,
    //            min: 0,
    //            max: 50,
    //            itemHeight: 120,
    //            calculable: true,
    //            precision: 0.1,
    //            text: ['明暗：二氧化硫'],
    //            textGap: 30,
    //            textStyle: {
    //                color: '#fff'
    //            },
    //            inRange: {
    //                colorLightness: [1, 0.5]
    //            },
    //            outOfRange: {
    //                color: ['rgba(255,255,255,.2)']
    //            },
    //            controller: {
    //                inRange: {
    //                    color: ['#c23531']
    //                },
    //                outOfRange: {
    //                    color: ['#444']
    //                }
    //            }
    //        }
    //    ],
    //    /*所示图例的数据模板*/
    //    series: [
    //        {
    //            name: '北京',
    //            type: 'scatter',
    //            itemStyle: itemStyle,
    //            data: dataBJ
    //        },
    //        {
    //            name: '上海',
    //            type: 'scatter',
    //            itemStyle: itemStyle,
    //            data: dataSH
    //        },
    //        {
    //            name: '广州',
    //            type: 'scatter',
    //            itemStyle: itemStyle,
    //            data: dataGZ
    //        }
    //    ]
    //};
};