;define(function(require, exports, module){

    // 请求依赖的资源文件
    require('../public/js/component');
    require('../creativityCenter/creativity.css');
             
    var prepage,                  // 上一个页面id值
        pageParam;                // 页面参数


    var ideaImgs   = new Array(), // 缓存图片
        techImgs   = new Array(),
        designImgs = new Array();


    // 类型与顶部标题的映射
    var type2Title = {
        'N-MK_CYDS': '创意大赛',
        'N-MK_SJXQ': '设计需求', 
        'N-MK_JSXQ': '技术需求', 
        'N-MK_SJFA': '设计方案', 
        'N-MK_JSFA': '技术方案', 
        'N-MK_QSMX': '奇思妙想',
        'Y-MK_QSMX': '我的创意', 
        'Y-MK_SJFA': '我的方案',
        'Y-MK_JSFA': '我的方案',
        'Y-MK_FA'  : '我的方案',
    };

    /* 设计方案 */
    var designPublish = {
        template: function(){
            return '<div class="publish-form" data-type="MK_SJFA">' + 
                    '<div class="clearfix">' + 
                        '<label class="publish-titile require">标题</label>' +
                        '<div class="block-right">' +
                            '<input type="text" placeholder="请输入标题(不超过15字)"  ' +
                            'role="form-data" data-key="title" data-name="设计方案标题" maxlength="15" class="required" -m-autofocus/>' +
                        '</div>' +
                    '</div>' +
                    '<div class="clearfix">' + 
                        '<label class="require">设计说明</label>' +
                        '<div class="block-right">' +
                            '<textarea rows="3" role="form-data" data-key="description" data-name="设计说明" class="required" ' + 
                            'placeholder="请从外观、颜色、细节、特性、可操作性等方面对设计方案进行描述"></textarea>' +
                        '</div>' +
                    '</div>' +
                    '<div class="clearfix">' + 
                        '<label class="require">使用场景</label>' +
                        '<div class="block-right">' +
                            '<textarea rows="3"  role="form-data" data-key="scene" data-name="使用场景" class="required" ' +
                            'placeholder="请详细描述您的设计方案的使用场景，所需要的功能平台或可以针对性解决何种问题等" maxlength="100"></textarea>' +
                        '</div>' +
                    '</div>' +
                    '<div class="clearfix">' + 
                        '<label class="require">设计方案图示</label>' +
                        '<div class="block-right upload-imgs required" role="form-data" data-type="list" data-key="imgUrls"  data-name="设计方案图示" >' +
                            // '<span class="sp-img">' +
                                // '<img src="../public/images/ICON.png" data-type="list-item" data-value="../public/images/ICON.png"/>' +
                            // '</span>' + 
                            '<span class="add-img add-design-img"></span>' + 
                        '</div>' +
                    '</div>' +
                    '<div class="clearfix">' + 
                        '<label>主要创新点</label>' +
                        '<div class="block-right">' +
                            '<textarea rows="3" role="form-data" data-name="主要创新点" data-key="invovate" ' +
                            'placeholder="请简要描述您的设计最核心的竞争力，差异化功能或模式创新" maxlength="100"></textarea>' +
                        '</div>' +
                    '</div>' +
                    '<div class="clearfix">' + 
                        '<label class="require">产品类别</label>' +
                        '<div class="block-right choose-type icon-arrow">' +
                            '<span role="form-data" data-key="productType" class="placeholder required" data-name="产品类别">请选择产品类型</span>' +
                            '<span role="form-data" data-key="productTypeName" style="display:none;"></span>' +
                        '</div>' +
                    '</div>' +
                    '<div class="clearfix">' + 
                        '<label class="require">合作模式</label>' +
                        '<div class="block-right choose-mode icon-arrow">' +
                            '<span role="form-data" data-key="cooperationMode"  class="placeholder required"  data-name="合作模式">合作模式</span>' +
                            '<span role="form-data" data-key="cooperationModeName" style="display:none" ></span>' +
                        '</div>' +
                    '</div>' +
                    '<div class="clearfix">' + 
                        '<label class="require">知识产权情况</label>' +
                        '<div class="block-right choose-ipo icon-arrow">' +
                            '<span role="form-data" data-key="property"  class="placeholder required"  data-name="知识产权情况">知识产权情况</span>' +
                            '<span role="form-data" data-key="propertyName" style="display:none" ></span>' +
                        '</div>' +
                    '</div>' +
                    '<div class="clearfix">' + 
                        '<label class="require">关键字</label>' +
                        '<div class="block-right">' + 
                            '<input type="text" placeholder="用于关联创意推荐(不超过5字)" role="form-data" data-key="keyword" data-name="关键字" maxlength="5" class="required" />' +
                        '</div>' +
                    '</div>' +
                 '</div>' +
                 // '<p class="terms-use"><span type="checkbox"></span>我同意<a href="">《九牧使用条款》</a></p>' +
                 '<p class="p-publish"><span class="sp-publish pb-design">提交</span></p>' +
                 '<div class="div-tips">' + 
                        '<p><i class="icon-warn"></i>温馨提示：发布方案将获得积分奖励</p>' + 
                        // '<p>1. 发布方案将获得积分奖励</p>' +
                        // '<p>2. 每天发布的前5条方案会获得积分奖励</p>' +
                 '</div>';
        },
        initEvent: function(page, parent, matchCode, matchTitle, matchType){

            // 获取产品类别
            app.chooseList('产品类别', 'CPLB', 'list-radio', '[data-type="MK_SJFA"] .choose-type', function(key, val){
                
                var $productType = $('[data-type="MK_SJFA"] span[data-key="productType"]');

                $productType.attr('data-value', key);
                $('[data-type="MK_SJFA"] span[data-key="productTypeName"]').attr('data-value', val);
                val.trim() ? $productType.html(val).removeClass('placeholder') : $productType.html('知识产权情况').addClass('placeholder');
            });

            // 获取合作模式
            app.chooseList('合作模式', 'HZFS', 'list-select', '[data-type="MK_SJFA"] .choose-mode', function(values){
                var vals = new Array(),
                    keys = new Array();

                values.forEach(function(i){
                    vals.push(i.value);
                    keys .push(i.key);
                });
                var $mode = $('[data-type="MK_SJFA"] span[data-key="cooperationMode"]');

                $mode.attr('data-value', keys.join(','));
                $('[data-type="MK_SJFA"] span[data-key="cooperationModeName"]').attr('data-value', vals.join('、'));

                vals.length ? $mode.html(vals.join('、')).removeClass('placeholder') : $mode.html('合作模式').addClass('placeholder');
            });

            // 获取知识产权情况
            app.chooseList('知识产权情况', 'ZSCQ', 'list-radio', '[data-type="MK_SJFA"] .choose-ipo', function(key, val){
                var $prototype = $('[data-type="MK_SJFA"] span[data-key="property"]');
                
                $prototype.attr('data-value', key);
                $('[data-type="MK_SJFA"] span[data-key="propertyName"]').attr('data-value', val);
                
                val.trim() ? $prototype.html(val).removeClass('placeholder') : $prototype.html('知识产权情况').addClass('placeholder');
            });

            // 提交
            $(document).off('click', '#' + page.option.id + ' .sp-publish.pb-design');
            $(document).on ('click', '#' + page.option.id + ' .sp-publish.pb-design', function(){
                var formData = baseInfo.getFormData('.publish-form[data-type="MK_SJFA"]');
                if(!formData) return;
                
                formData.planType = 'MK_SJFA';

                matchCode  && (formData.matchCode  = matchCode );
                matchTitle && (formData.matchTitle = matchTitle);
                matchType  && (formData.matchType  = matchType);

                app.ajax({
                            type: 'POST',
                            url : 'plan/savePlan',
                            data: formData,
                            beforeSend: function(){
                                $.showPreloader('提交中...');
                            }
                         }, function(data){
                            $.alert('方案提交成功！', function(){
                                    app.back(-1);
                                });
                         });
            });

            // 上传照片
            require.async(['../imgLoader/imageUp'], function(a){
                new a.imgUpLoader({
                    trigger   : '.add-design-img', // 触发图片上传
                    isMultiple: true,              // 是否多选
                    fn        : function(img){     // 回调事件
                                    if(parent.find('.sp-img img').size() > 8) throw '图片不能超过九张';
                                    parent.find('.add-design-img').before('<span class="sp-img"><i class="del-img"></i><img src="' + img + '" data-type="list-item" data-value="' + img + '"/></span>');
                                }
                }).init();
            });
        }
    };
    /* 技术方案 */
    var techPublish = {
        template: function(data){
            return '<div class="publish-form" data-type="MK_JSFA">' + 

                    '<div class="clearfix">' + 
                        '<label  class="publish-titile require">标题</label>' +
                        '<div class="block-right">' +
                            '<input type="text" placeholder="请输入标题(不超过15字)" role="form-data" class="required" data-name="技术方案标题" data-key="title" maxlength="15" -m-autofocus/>' +
                        '</div>' +
                    '</div>' +
                    '<div class="clearfix">' + 
                        '<label class="require">设计说明</label>' +
                        '<div class="block-right">' +
                            '<textarea rows="3" placeholder="请对技术做简要描述" class="required" role="form-data" data-name="设计说明" data-key="description"></textarea>' +
                        '</div>' +
                    '</div>' +
                    
                    '<div class="clearfix">' + 
                        '<label class="require">技术图示</label>' +
                        '<div class="block-right upload-imgs required" role="form-data" data-name="技术图示" data-type="list" data-key="imgUrls">' +
                            // '<span class="sp-img" data-type="list-item" data-value="../public/images/ICON.png">' +
                            //     '<img src="../public/images/ICON.png"/>' +
                            // '</span>' + 
                            '<span class="add-img add-tech-img"></span>' + 
                        '</div>' +
                    '</div>' +
                    '<div class="clearfix">' + 
                        '<label class="require">主要创新点</label>' +
                        '<div class="block-right">' +
                            '<textarea rows="3" class="required" placeholder="请简要描述您的设计最核心的竞争力，差异化功能或模式创新" maxlength="100" role="form-data" data-name="主要创新点" data-key="invovate"></textarea>' +
                        '</div>' +
                    '</div>' +
                    '<div class="clearfix">' + 
                        '<label class="require">能实现的指标</label>' +
                        '<div class="block-right">' +
                            '<textarea rows="3" class="required" placeholder="请详细描述您的技术可实现的技术指标及性能指标、功耗、成本等" maxlength="100" role="form-data" data-name="能实现的指标" data-key="target"></textarea>' +
                        '</div>' +
                    '</div>' +
                    '<div class="clearfix">' + 
                        '<label class="require">使用场景</label>' +
                        '<div class="block-right">' +
                            '<textarea rows="3" class="required" placeholder="请详细描述您的设计方案的使用场景，所需要的功能平台或可以针对性解决何种问题等"  maxlength="100"  role="form-data" data-name="使用场景" data-key="scene"></textarea>' +
                        '</div>' +
                    '</div>' +
                    '<div class="clearfix">' + 
                        '<label class="require">合作模式</label>' +
                        '<div class="block-right choose-mode icon-arrow">' +
                            '<span role="form-data" class="placeholder required" data-key="cooperationMode"  data-name="合作模式">合作模式</span>' +
                            '<span role="form-data" data-key="cooperationModeName" style="display:none" ></span>' +
                        '</div>' +
                    '</div>' +
                    '<div class="clearfix">' + 
                        '<label class="require">成熟度</label>' +
                        '<div class="block-right choose-mature icon-arrow">' +
                            '<span role="form-data" class="placeholder required"  data-key="mature" data-name="成熟度">成熟度</span>' +
                            '<span role="form-data" data-key="matureName" style="display:none" ></span>' +
                        '</div>' +
                    '</div>' +
                    '<div class="clearfix">' + 
                        '<label class="require">知识产权情况</label>' +
                        '<div class="block-right choose-ipo icon-arrow">' +
                            '<span role="form-data" class="placeholder required"  data-key="property" data-name="知识产权情况">知识产权情况</span>' +
                            '<span role="form-data" data-key="propertyName" style="display:none" ></span>' +
                        '</div>' +
                    '</div>' +
                    '<div class="clearfix">' + 
                        '<label class="require">技术领域</label>' +
                        '<div class="block-right choose-field icon-arrow">' +
                            '<span role="form-data"  class="placeholder required" data-key="field" data-name="技术领域">技术领域</span>' +
                            '<span role="form-data" data-key="fieldName" style="display:none" ></span>' +
                        '</div>' +
                    '</div>' +
                    '<div class="clearfix">' + 
                        '<label>在线视频播放地址</label>' +
                        '<div class="block-right">' +
                            '<textarea rows="3" placeholder="请输入视频地址" role="form-data" data-key="videoAddress" data-name="在线视频播放地址"></textarea>' +
                        '</div>' +
                    '</div>' +
                    '<div class="clearfix">' + 
                        '<label class="require">关键字</label>' +
                        '<div class="block-right">' +
                            '<input type="text" placeholder="用于关联创意推荐(不超过5字)" role="form-data" data-key="keyword" data-name="关键字" maxlength="5" class="required" />' +
                        '</div>' +
                    '</div>' +
                 '</div>' +
                 // '<p class="terms-use"><span type="checkbox"></span>我同意<a href="">《九牧使用条款》</a></p>' +
                 '<p class="p-publish"><span class="sp-publish pb-tech">提交</span></p>' +
                 '<div class="div-tips">' + 
                        '<p><i class="icon-warn"></i>温馨提示：发布方案将获得积分奖励</p>' + 
                        // '<p>1. 发布方案将获得积分奖励</p>' +
                        // '<p>2. 每天发布的前5条方案会获得积分奖励</p>' +
                 '</div>';
        },
        initEvent: function(page, parent, matchCode, matchTitle, matchType){
            
            // 获取合作模式 成熟度 知识产权情况 技术领域
            app.chooseList('合作模式', 'HZFS', 'list-select', '[data-type="MK_JSFA"] .choose-mode', function(values){
                var vals = new Array(),
                    keys  = new Array();

                values.forEach(function(i){
                    vals.push(i.value);
                    keys .push(i.key);
                });
                var $mode = $('[data-type="MK_JSFA"] span[data-key="cooperationMode"]');

                $mode.attr('data-value', keys.join(','));
                $('[data-type="MK_JSFA"] span[data-key="cooperationModeName"]').attr('data-value', vals.join('、'));

                vals.length ? $mode.html(vals.join('、')).removeClass('placeholder') : $mode.html('合作模式').addClass('placeholder');
            });

            app.chooseList('成熟度', 'CSD', 'list-radio', '[data-type="MK_JSFA"] .choose-mature', function(key, val){
                var $mature = $('[data-type="MK_JSFA"] span[data-key="mature"]');

                $mature.attr('data-value', key);
                $('[data-type="MK_JSFA"] span[data-key="matureName"]').attr('data-value', val);

                val.trim() ? $mature.html(val).removeClass('placeholder') : $mature.html('成熟度').addClass('placeholder'); 
            });
            
            app.chooseList('知识产权情况', 'ZSCQ', 'list-radio', '[data-type="MK_JSFA"] .choose-ipo', function(key, val){
                var $ipo = $('[data-type="MK_JSFA"] span[data-key="property"]');

                $ipo.attr('data-value', key);
                $('[data-type="MK_JSFA"] span[data-key="propertyName"]').attr('data-value', val).html(val);

                val.trim() ? $ipo.html(val).removeClass('placeholder') : $ipo.html('知识产权情况').addClass('placeholder');
            });
            
            app.chooseList('技术领域', 'JSLY', 'list-radio', '[data-type="MK_JSFA"] .choose-field', function(key, val){
                var $field = $('[data-type="MK_JSFA"] span[data-key="field"]');
                $field.attr('data-value', key);
                $('[data-type="MK_JSFA"] span[data-key="fieldName"]').attr('data-value', val);

                val.trim() ? $field.html(val).removeClass('placeholder') : $field.html('技术领域').addClass('placeholder');
            });

            /* 事件监听 */
            $(document).off('click', '#' + page.option.id + ' .sp-publish.pb-tech');
            $(document).on ('click', '#' + page.option.id + ' .sp-publish.pb-tech', function(){
                var formData = baseInfo.getFormData('.publish-form[data-type="MK_JSFA"]');
                if(!formData) return;
                formData.planType = 'MK_JSFA';
                
                if(matchCode)  formData.matchCode  = matchCode;
                if(matchTitle) formData.matchTitle = matchTitle;
                if(matchType)  formData.matchType  = matchType;

                app.ajax({
                            type: 'POST',
                            url : 'plan/savePlan',
                            data: formData,
                            beforeSend: function(){
                                $.showPreloader('提交中...');
                            }
                         }, function(data){
                            $.alert('方案提交成功！', function(){
                                    app.back(-1);
                                });
                         });
            });

            // 上传照片
            require.async(['../imgLoader/imageUp'], function(a){
                new a.imgUpLoader({
                    trigger   : '.add-tech-img',
                    isMultiple: true,
                    fn        : function(img){
                                    if(parent.find('.sp-img img').size() > 8) throw '图片不能超过九张';
                                    parent.find('.add-tech-img').before('<span class="sp-img"><i class="del-img"></i><img src="' + img + '" data-type="list-item" data-value="' + img + '"/></span>');
                                }
                }).init();
            });
        }
    };

    /* 发布创意 */
    var ideaPublish = {
        template: function(){
            return '<div class="publish-form publihs-idea-form" data-type="MK_CY">' + 
                        '<div class="clearfix">' + 
                            '<label class="publish-titile require">创意标题</label>' +
                            '<div class="block-right">' +
                                '<input type="text" placeholder="请输入标题(不超过15字)" role="form-data" data-name="创意标题" maxlength="15" data-key="title" class="required" -m-autofocus/>' +
                            '</div>' +
                        '</div>' +
                        '<div class="clearfix">' + 
                            '<label class="require">创意描述</label>' +
                            '<div class="block-right">' +
                                '<textarea rows="3" placeholder="简单描述一下创意内容" role="form-data" data-key="description" data-name="创意描述" maxlength="1000" class="required"></textarea>' +
                            '</div>' +
                        '</div>' +
                        '<div class="clearfix">' + 
                            '<label class="require">产品类别</label>' +
                            '<div class="block-right choose-type icon-arrow">' +
                                '<span role="form-data" class="placeholder required"  data-key="productType" data-name="产品类别" >请选择产品类型</span>' +
                                '<span role="form-data" data-key="productTypeName" style="display:none;"></span>' +
                            '</div>' +
                        '</div>' +
                        '<div class="clearfix">' + 
                            '<label class="require">上传图片</label>' +
                            '<div class="block-right upload-imgs required" role="form-data" data-type="list" data-name="上传图片" data-key="imgUrls">' +
                                // '<span class="sp-img"><img src="../public/images/ICON.png" data-type="list-item" data-value="../public/images/ICON.png"/></span>' + 
                                '<span class="add-img add-idea-img"></span>' +
                                // '<input type="file" id="img-uploader" multiple/>' +
                            '</div>' +
                        '</div>' +
                        '<div class="clearfix">' + 
                            '<label>补充说明</label>' +
                            '<div class="block-right">' +
                                '<textarea rows="3" placeholder="补充说明" role="form-data" data-key="content"></textarea>' +
                            '</div>' +
                        '</div>' +
                        '<div class="clearfix">' + 
                            '<label class="require">关键字</label>' +
                            '<div class="block-right">' +
                                '<input type="text" placeholder="系统可为您推荐方案(不超过5字)" class="required" role="form-data" data-key="keyword" data-name="关键字" maxlength="5"/>' +
                            '</div>' +
                        '</div>' +
                  '</div>' +
                  '<p class="p-publish"><span class="sp-publish">发布</span></p>' +
                  '<div class="div-tips">' + 
                        '<p><i class="icon-warn"></i>温馨提示：发布创意将获得积分奖励</p>' + 
                        // '<p>1. 发布创意将获得积分奖励</p>' +
                        // '<p>2. 每天发布的前5条创意会获得积分奖励</p>' +
                  '</div>';
        },
        initEvent: function(page, parent, matchCode, matchTitle, matchType){
        
            // 获取产品类别
            app.chooseList('产品类别', 'CPLB', 'list-radio', '[data-type="MK_CY"] .choose-type', function(key, val){
                var $productType = $('[data-type="MK_CY"] span[data-key="productType"]');

                $productType.attr('data-value', key).html(val);
                
                $('[data-type="MK_CY"] span[data-key="productTypeName"]').attr('data-value', val);
                val.trim() ? $productType.html(val).removeClass('placeholder') : $productType.html('产品类别').addClass('placeholder');
            });

            // 发布
            $(document).off('click', '#' + page.option.id + ' .sp-publish');
            $(document).on('click', '#' + page.option.id + ' .sp-publish', function(){

                var formData = baseInfo.getFormData('.publish-form[data-type="MK_CY"]');
                if(!formData) return;
                
                if(matchCode ) formData.matchCode  = matchCode;
                if(matchTitle) formData.matchTitle = matchTitl;
                if(matchType ) formData.matchType  = matchType;

                app.ajax({
                            data: formData,
                            url : 'idea/saveIdea',
                            beforeSend: function(){
                                $.showPreloader('提交中...');
                            }
                         },function(data){
                            prepage = app.pageIdCache[app.pageIdCache.length - 2];
                            $.alert('发布成功！', function(){
                                var QXMSList;
                                if(app.pageGroup && 
                                    app.pageGroup[prepage] && 
                                    app.pageGroup[prepage].components && 
                                    (QXMSList = app.pageGroup[prepage].components['tab-qsmx_list'])) { 
                                    // 详情页
                                    QXMSList && QXMSList.refresh();
                                }
                                app.back(-1);
                            });
                         });
            });
            
            // 上传照片
            require.async(['../imgLoader/imageUp'], function(a){
                new a.imgUpLoader({
                    trigger   : '.add-idea-img',
                    isMultiple: true,
                    fn        : function(img){
                                    if(parent.find('.sp-img img').size() > 8) throw '图片不能超过九张';
                                    parent.find('.add-idea-img').before('<span class="sp-img"><i class="del-img"></i><img src="' + img + '" data-type="list-item" data-value="' + img + '"/></span>');
                                }
                }).init();
            });
        }
    };
   
    // 对外暴露入口：参数param {pageType, isMy, type, code<如果是详情页>, matchCode<如果是发布页>}
    exports.toPage = function(param){
        pageParam  = param;
        switch(pageParam.pageType){
            case 'list'   : return getListPage(pageParam.isMy, pageParam.type, 'page-create-list').init();
            case 'detail' : return getDetailPage (pageParam.isMy, pageParam.type, pageParam.code, pageParam.title, 'page-default').init(); 
            case 'publish-idea'  : return getIdeaPublishPage().init();
            case 'publish-tech'  : return getTechPublishPage().init();
            case 'publish-design': return getDesignPublishPage().init();
            case 'publish-fa'    : return getSchemePublishPage().init();
        }
    };

    // 监听在document上的事件
    $(function(){
        // 发布页 设置滚动条回到顶部
        $(document).on('pageAnimationStart', '.page-publish' , function(e, id, $page){
            // sui组件会在页面初始化之后设置滚动条高度，需要加延迟来重置初始化高度
            setTimeout(function(){
                $('#' + id + ' .content').scrollTop(0);
            }, 100);
        });

        $(document).on('loginSuccess', function(){
            prepage = app.pageIdCache[app.pageIdCache.length - 2];

            if(prepage.option && prepage.option.id.indexOf('detail') === -1) return;

            var _data = app.pageGroup[prepage].option.param;
            app.ajax({
                url: 'common/detail',
                data: {
                    type: _data.type,
                    code: _data.code
                },
                beforeSend: function(){}
            },function(data){
                data = data.detail;

                if(data.likeFlag === 'Y'){
                    $('#' + prepage + ' .nv-zan').attr('zan-status', 'Y');
                }
                if(data.collectionFlag === 'Y'){
                    $('#' + prepage + ' .nv-star').attr('star-status', 'Y');
                }
            });
        });

        $(document).on('click', '.sp-img .del-img', function(e){
            $(e.currentTarget).parent('.sp-img').remove();
        });
    });  


    function getListPage(isMy, type, id, cls){

        return new app.page({
                    id : id,
                    cls: (cls && cls.trim() ? cls : '') + ' temp',
                    header: {
                        title : type2Title[isMy + '-' + type]
                    },
                    search: {
                        renderKey: type + '-list',
                    },
                    content: {
                        List: {
                            cls: 'list-render',
                            key: type + '-list',
                            ajaxParam: {
                                url: 'common/list',
                                data: {
                                    p    : 0,
                                    s    : 5,
                                    type : type,
                                    isMy : isMy
                                }
                            },
                            template: getListItems(type),
                            clickFn: function(e){
                                var $e = $(e.currentTarget);
                                getDetailPage( pageParam.isMy, 
                                               $e.attr('data-type') ? $e.attr('data-type') : type, 
                                               $e.attr('data-code'),
                                               $e.attr('data-title'),
                                               'page-detail').init().go();
                                setTimeout(function(){
                                    // 阅读数
                                    var _num;
                                    (_num = $e.find('.reads-icon').text()) !== '99+' && $e.find('.reads-icon').text(helper.nc(Number(_num) + 1));
                                }, 200);
                            },
                            isAddmore: true
                        }
                    }
                });
    }

    function getDetailPage(isMy, type, code, title, id, cls){
            /*
            *  创意大赛详情：活动详情、奇思妙想、创新方案、评选结果
            *  设计需求详情：需求详情、奇思妙想、创新方案
            *  技术需求详情：需求详情、相关方案
            *  设计方案详情：方案详情、相关需求
            *  技术方案详情：方案详情、相关需求
            *  奇思妙想详情：创意详情、相关方案
            *  我的创意详情：创意详情、相关方案、进度信息
            *  我的方案详情：方案详情、相关需求、方案进度
            */

        var type2Op = {
                        'N-MK_CYDS': ['content-detail', 'qsmx-list', 'fa-list', 'activity-result'],
                        'N-MK_SJXQ': ['content-detail', 'qsmx-list', 'fa-list'],
                        'N-MK_JSXQ': ['content-detail', 'fa-list'],
                        'N-MK_SJFA': ['content-detail', 'zt-list'],
                        'N-MK_JSFA': ['content-detail', 'xq-list'],
                        'N-MK_QSMX': ['content-detail', 'fa-list'],
                        'Y-MK_QSMX': ['content-detail', 'fa-list', 'progress-idea'],
                        'Y-MK_FA'  : ['content-detail', 'xq-list', 'progress-plan']
                     },
            type2TabName = {
                            'MK_CYDS': '活动详情',
                            'MK_SJXQ': '需求详情',
                            'MK_JSXQ': '需求详情',
                            'MK_SJFA': '方案详情',
                            'MK_JSFA': '方案详情',
                            'MK_QSMX': '创意详情'
                        };
 
        function getTabOps(type, isMy){
            var flag = true;
            var allTabOps = {
                // 详情
                'content-detail':{
                    text    : type2TabName[type],
                    key     : 'tab-detail',
                    dataOf  : 'detail-panel',
                    template: detailHtml(type),
                    // 第一次生成该tab内容的时候的回调函数
                    initCb  : function(data, parent, page){
                        data = data.detail;
                        // $('.swiper-container').swiper();
                        /* 评论列表 */
                    
                        new app.commentSection(page, parent, {
                            // key, type, code, commentPageKey
                            key: 'detail-comment-section',
                            cls: 'comment-list',
                            ajaxParam: {
                                url : 'common/commentList',
                                data:{
                                    p: 0,
                                    s: 5,
                                    code: code,
                                    type: type,
                                },
                                beforeSend: function(){}
                            },
                            commentPageKey: 'detail-comment-page', // 关联评论页key
                        }).init();
                    },
                    // 切换到该tab时候的回调函数，重新初始化
                    clickCb: function(){
                        $('.swiper-container').swiper();
                    }
                },
                // 奇思妙想
                'qsmx-list':{ 
                    text    : '奇思妙想',
                    key     : 'tab-qsmx',
                    template: function(data, parent, page){
                        try{
                        new app.List(page, parent, {
                                cls: 'tab-qsmx-list-render list-render',
                                key: 'tab-qsmx_list',
                                ajaxParam: {
                                    url: 'common/list',
                                    data: {
                                        p    : 0,
                                        s    : 5,
                                        type : 'MK_QSMX',
                                        matchCode: code
                                    },
                                    beforeSend: function(){
                                        parent.html('<div class="me-modal-text modal-text"><div class="preloader"></div></div>').attr('data-status', 'loading');
                                    },
                                },
                                template: getListItems('MK_QSMX'),
                                clickFn: function(e){
                                    getDetailPage('N', 'MK_QSMX', $(e.currentTarget).attr('data-code'), $(e.currentTarget).attr('data-title'), 'page-match-qsmx-detail').init().go();
                                },
                                isAddmore: true
                            }).init();
                        }catch(e){console.log(e)};
                    }
                },
                // 创新方案('MK_FA')、相关方案('MK_FA'，技术方案)
                'fa-list': { 
                    text    : '创新方案',
                    key     : 'tab-cxfa',
                    template: function(data, parent, page){

                        var param = {
                                        p   : 0,
                                        s   : 5,
                                        type: 'MK_FA',
                                        matchCode: code
                                    };
                        $('#' + page.option.id + ' .detail-keyword').size() && (param.keyword = $('#' + page.option.id + ' .detail-keyword').attr('data-value'));

                        new app.List(page, parent, {
                                cls: 'tab-cxfa-list-render list-render',
                                key: 'tab-cxfa_list',
                                ajaxParam: {
                                    url: 'common/list',
                                    data: param,
                                    beforeSend: function(){
                                        parent.html('<div class="me-modal-text modal-text"><div class="preloader"></div></div>').attr('data-status', 'loading');
                                    }
                                },
                                template: getListItems('MK_FA'),
                                clickFn: function(e){
                                    var $e = $(e.currentTarget);
                                    getDetailPage('N', $e.attr('data-type'), $e.attr('data-code'), $e.attr('data-title'), 'N-MK_FA-detail').init().go();
                                },
                                isAddmore: true
                            }).init();
                    }
                },
                // 相关需求('MK_ZT' 创意大赛、设计需求)
                'zt-list': { 
                    text    : '相关需求',
                    key     : 'tab-xgzt',
                    template: function(data, parent, page){
                        new app.List(page, parent, {
                                cls: 'tab-xgzt-list-render list-render',
                                key: 'tab-xgzt_list',
                                ajaxParam: {
                                    url: 'common/relateList',
                                    data: {
                                        p   : 0,
                                        s   : 5,
                                        type: 'MK_SJFA',
                                        code: code
                                    },
                                    beforeSend: function(){
                                        parent.html('<div class="me-modal-text modal-text"><div class="preloader"></div></div>').attr('data-status', 'loading');
                                    }
                                },
                                template: getListItems('MK_ZT'),
                                clickFn: function(e){
                                    var $e = $(e.currentTarget);
                                    getDetailPage('N', $e.attr('data-type'), $e.attr('data-code'),  $e.attr('data-title'), 'relative-zt-detail').init().go();
                                },
                                isAddmore: true
                            }).init();
                    }
                },
                // 相关需求('MK_XQ' 创意大赛、技术需求)
                'xq-list': { 
                    text    : '相关需求',
                    key     : 'tab-cxfa',
                    template: function(data, parent, page){

                        var _param = {
                                        p    : 0,
                                        s    : 5,
                                        type : 'MK_JSFA',
                                        code : code,
                                    };

                        $('#' + page.option.id + ' .detail-keyword').size()      && (_param.key   = $('#' + page.option.id + ' .detail-keyword').attr('data-value'));
                        $('#' + page.option.id + ' .detail-header-title').size() && (_param.title = $('#' + page.option.id + ' .detail-header-title').attr('data-value'));

                        new app.List(page, parent, {
                                cls: 'tab-xgxq-list-render list-render',
                                key: 'tab-xgxq_list',
                                ajaxParam: {
                                    url: 'common/relateList',
                                    data: _param,
                                    beforeSend: function(){
                                        parent.html('<div class="me-modal-text modal-text"><div class="preloader"></div></div>').attr('data-status', 'loading');
                                    }
                                },
                                template: getListItems('MK_XQ'),
                                clickFn: function(e){
                                    var $e = $(e.currentTarget);
                                    getDetailPage('N', $e.attr('data-type'), $e.attr('data-code'), $e.attr('data-title'), 'N-MK_FA-detail').init().go();
                                },
                                isAddmore: true
                            }).init();
                    }
                },
                // 评选结果
                'activity-result': {
                    text   : '评选结果',
                    key    : 'tab-result',
                    ajaxParam:{
                        url : 'match/matchResult',
                        data: {
                            matchCode: code
                        },
                        beforeSend: function(){
                            $('.tab-result-content').html('<div class="me-modal-text modal-text"><div class="preloader"></div></div>').attr('data-status', 'loading');
                        }
                    },
                    template: function(data, $content){
                        var _html = '';

                        var key2name = {
                            'JX_YDJ' : '一等奖',
                            'JX_EDJ' : '二等奖',
                            'JX_SDJ' : '三等奖'
                        };

                        var _data = {
                            'JX_YDJ' : [],
                            'JX_EDJ' : [],
                            'JX_SDJ' : []
                        };

                        data.list.forEach(function(item){
                            item.rank === 'JX_YDJ' ? _data['JX_YDJ'].push(item) : (item.rank === 'JX_EDJ' ? _data['JX_EDJ'].push(item) : _data['JX_SDJ'].push(item)) 
                        })
                        for(i in _data){
                            if(!_data.length) return;
                            _html  += '<p class="info-title">' + key2name[i] + '</p><ul class="list-render">';
                            _data[i].forEach(function(e){

                                _html += '<li class="clearfix touchable li-item-cd" data-title="' + e.title + '" data-code="' + e.code + '" data-type="' + e.type + '">' + 
                                        '<div class="block-left">' + 
                                            '<img class="head-img" onerror="imgError(this)" src="' + app.imgServer + e.createUrl + '" alt="" />' +
                                        '</div>' +
                                        '<div class="block-left">' + 
                                            '<p class="idea-title">' + e.title + '</p>' +
                                            '<p><span class="idea-name">'  + e.createName  + 
                                                '</span><span class="idea-publish-date">' + cut(e.createDate) + '</span></p>' +
                                        '</div>' +
                                     '</li>';
                            });
                            _html += '</ul>';
                        }
                        
                        // $(document).off('click', '.tab-result-content li');
                        // $(document).on ('click', '.tab-result-content li', function(){
                        // });

                        return _html;
                    }
                },
                // 方案进度
                'progress-plan' : {
                    text   : '进度节点',
                    key    : 'tab-progress',
                    ajaxParam:{
                        url : 'plan/processList',
                        data: {
                            p: 0,
                            s: 5,
                            code: code
                        },
                        beforeSend: function(){
                            $('.tab-progress-content').html('<div class="me-modal-text modal-text"><div class="preloader"></div></div>').attr('data-status', 'loading');
                        }
                    },
                    template: function(data){
                        data = data.list;
                        var _html = '<table class="tb-progress">';
                        for(var i = 0; i < data.length; i++){
                            _html += '<tr>' +
                                        '<td>' + data[i].content + '</td>' +
                                        '<td>' + cut(data[i].createDate) + '</td>' +
                                    '</tr>';
                        }
                        _html += '</table>';
                        return _html;
                    },
                },
                // 进度信息
                'progress-idea' : {
                    text   : '进度信息',
                    key    : 'tab-progress',
                    ajaxParam:{
                        url : 'idea/processList',
                        data: {
                            p: 0,
                            s: 5,
                            code: code
                        },
                        beforeSend: function(){
                            $('.tab-progress-content').html('<div class="me-modal-text modal-text"><div class="preloader"></div></div>').attr('data-status', 'loading');
                        }
                    },
                    template: function(data){
                        data = data.list;
                        var _html = '<table class="tb-progress">';
                        for(var i = 0; i < data.length; i++){
                            _html += '<tr>' +
                                        '<td>' + data[i].content + '</td>' +
                                        '<td>' + cut(data[i].createDate) + '</td>' +
                                    '</tr>';
                        }
                        _html += '</table>';
                        return _html;
                    },
                }
            };

            var _temp = [],
                _type = (isMy === 'Y' && (type === 'MK_JSFA' || type === 'MK_SJFA') ? 'MK_FA' : type),
                _op   = type2Op[isMy + '-' +  _type];

            for(var i = 0; i < _op.length; i++){
                _temp.push(allTabOps[_op[i]]);
            }
            
            return $.extend([], _temp, true);
        }
        function getNavOps(type){
            switch(type){
                case 'MK_CYDS':
                case 'MK_SJXQ': return [{
                                                key  : 'key-nv-0',
                                                liCls: 'nv-li-7-1',
                                                aCls : 'nv-comment open-comment',
                                                clickFn: function(e, self){
                                                    if(isLogin()){
                                                        // 显示评论页 并绑定评论列表
                                                        self.page.components['detail-comment-page'].show('detail-comment-section');
                                                    }
                                                }
                                            },{
                                                key  : 'key-nv-1',
                                                liCls: 'nv-li-7-1',
                                                aCls : 'nv-zan',
                                            },{
                                                key  : 'key-nv-2',
                                                liCls: 'nv-li-7-1',
                                                aCls : 'nv-star star-icon',
                                            },{
                                                key  : 'key-nv-3',
                                                text : '我有想法',
                                                liCls: 'nv-li-7-2',
                                                aCls : 'nv-idea',
                                                clickFn : function(e){
                                                    
                                                    if(isLogin()){
                                                        // 创意大赛 超过截止日期 不在允许发布 我的想法
                                                        if( type === 'MK_CYDS' && new Date() >  helper.getDate($('.detail-closing-date').attr('data-value'))){
                                                            $.toast('已经超过大赛截止日期');
                                                            $(e.target).addClass('unclickable');
                                                            return;
                                                        }
                                                        getIdeaPublishPage(code, title, type).init().go();
                                                    }  
                                                }
                                            },{
                                                key  : 'key-nv-4',
                                                text : '我有方案',
                                                liCls: 'nv-li-7-2',
                                                aCls : 'nv-scheme',
                                                clickFn : function(e){
                                                    if(isLogin()){
                                                        // 创意大赛 超过截止日期 不在允许发布 我的方案
                                                        if( type === 'MK_CYDS' && new Date() >  helper.getDate($('.detail-closing-date').attr('data-value'))){
                                                            $.toast('已经超过大赛截止日期');
                                                            $(e.target).addClass('unclickable');
                                                            return;
                                                        }
                                                        getSchemePublishPage(code, title, type).init().go();
                                                    } 
                                                }
                                        }];
                break;
                case 'MK_JSXQ': return [{
                                                key  : 'key-nv-0',
                                                liCls: 'nv-li-5-1',
                                                aCls : 'nv-comment open-comment',
                                                clickFn: function(e, self){
                                                    if(isLogin()){
                                                        // 显示评论页 并绑定评论列表
                                                        self.page.components['detail-comment-page'].show('detail-comment-section');
                                                    }
                                                }
                                            },{
                                                key  : 'key-nv-1',
                                                liCls: 'nv-li-5-1',
                                                aCls : 'nv-zan',
                                            },{
                                                key  : 'key-nv-2',
                                                liCls: 'nv-li-5-1',
                                                aCls : 'nv-star star-icon',
                                            },{
                                                key  : 'key-nv-3',
                                                text : '我有方案',
                                                liCls: 'nv-li-5-2',
                                                aCls : 'nv-tech',
                                                clickFn : function(e){
                                                    isLogin() && getTechPublishPage(code, title, type).init().go();
                                                }
                                        }];
                break;
                case 'MK_QSMX': return [{
                                                key  : 'key-nv-0',
                                                liCls: 'nv-li-5-1',
                                                aCls : 'nv-comment open-comment',
                                                clickFn: function(e, self){
                                                    // 显示评论页 并绑定评论列表
                                                    if(isLogin()){
                                                        self.page.components['detail-comment-page'].show('detail-comment-section');
                                                    }
                                                }
                                            },{
                                                key  : 'key-nv-1',
                                                liCls: 'nv-li-5-1',
                                                aCls : 'nv-zan',
                                            },{
                                                key  : 'key-nv-2',
                                                liCls: 'nv-li-5-1',
                                                aCls : 'nv-star star-icon',
                                            },{
                                                key  : 'key-nv-3',
                                                text : '提交方案',
                                                liCls: 'nv-li-5-2',
                                                aCls : 'nv-scheme',
                                                clickFn : function(e){
                                                    isLogin() && getSchemePublishPage(code, title, type).init().go();
                                                }
                                        }];
                break;
                default: return [{
                                        key  : 'key-nv-0',
                                        liCls: 'nv-li-3-1',
                                        aCls : 'nv-comment open-comment',
                                        clickFn: function(e, self){
                                            if(isLogin()){
                                                // 显示评论页 并绑定评论列表
                                                self.page.components['detail-comment-page'].show('detail-comment-section');
                                            }
                                        }
                                    },{
                                        key  : 'key-nv-1',
                                        liCls: 'nv-li-3-1',
                                        aCls : 'nv-zan',
                                    },{
                                        key  : 'key-nv-2',
                                        liCls: 'nv-li-3-1',
                                        aCls : 'nv-star star-icon',
                                }];
                break;

            }
        }

        // 头部信息
        function headerHtml(data){

            data = data.detail;

            var _html = '<div class="detail-header">' +
                            '<p class="detail-header-title" data-title="' + data.title + '">' + data.title + '</p>' +
                            '<p>' + 
                                '<i class="author-grade"><img onerror="imgError(this)" src="' + app.imgServer + data.gradeUrl + '" alt="" /></i>' +
                                '<span class="detail-header-author">' + 
                                    (['MK_CYDS', 'MK_SJXQ', 'MK_JSXQ', 'MK_ZT', 'MK_XQ'].indexOf(type) !== -1 ? '九牧官方' : data.createName) + 
                                '</span>' +
                            '</p>' +
                            '<p>' + 
                                '<span class="detail-header-view reads-icon">' + data.readCount + '</span>' +
                                '<span class="detail-header-comment comments-icon" comment-num="' + data.commentCount + '">' + data.commentCount + '</span>' +
                                '<span class="detail-header-zan icon-zan" zan-num="' + data.likeCount + '">' + data.likeCount + '</span>' +
                                '<span class="detail-header-publish-date">' + cut(data.createDate) + '</span>' +
                            '</p>' +
                        '</div>';
            return _html;
        }

        // 详情页面
        function detailHtml(type){
            switch(type){
                // 创意大赛 详情
                case 'MK_CYDS': return function(data){
                    data = data.detail;
                    var _html = '<div class="detail-info">' +
                                    '<p class="info-title">简介</p>' +
                                    '<div class="activity-intro info-content">' + data.introduction + '</div>' +     
                                    '<p class="info-title">活动描述</p>' +
                                    '<div class="activity-desc info-content">' + helper.addImageServerUrl(data.description) + '</div>';
                        
                        data.creativePictures.length && (_html += '<p class="info-title">图片</p>' + app.getSwiper(data.creativePictures.map(function(img){
                            return app.imgServer + img.url;
                        })));
                
                        _html += '<p class="info-title">赛程安排</p>' +
                                    '<div class="detail-arrange info-content">' + data.arrange + '</div>' +
                                    '<p class="info-title">奖项设置</p>' +
                                    '<div class="detail-prize info-content">' + data.setup + '</div>' +
                                    '<p class="info-title">评选标准</p>' +
                                    '<div class="detail-eval info-content">' + data.standard + '</div>' +
                                    '<p class="info-title">截止时间</p>' +
                                    '<div class="detail-closing-date info-content" data-value="' + data.endDate + '">' + data.endDate + '</div>' +
                                '</div>';
                    return _html;
                };
                break;
                
                // 设计需求 详情
                case 'MK_SJXQ': return function(data){
                    data = data.detail;

                    var _html = '<div class="detail-info">' +
                                '<p class="info-title">简介</p>' +
                                '<div class="activity-intro info-content">' + data.introduction + '</div>' +   
                                '<p class="info-title">需求描述</p>' +
                                '<div class="detail-desc info-content">' + helper.addImageServerUrl(data.description) + '</div>' +
                                '<p class="info-title">背景描述</p>' +
                                '<div class="detail-backdrop info-content">' + data.backdrop + '</div>';
                        
                        data.creativePictures.length && (_html += '<p class="info-title">图片</p>' + app.getSwiper(data.creativePictures.map(function(img){
                            return app.imgServer + img.url;
                        })));
                        _html += '<p class="info-title">产品类别</p>' +
                                 '<div class="detail-type-name info-content">' + data.productTypeName + '</div>' +
                                 '<p class="info-title">关键字</p>' +
                                 '<div class="detail-keyword info-content" data-value="' + data.keyword + '">' + data.keyword + '</div>' +
                                 '</div>';
                    return _html;
                };
                break;
                
                // 技术需求 详情
                case 'MK_JSXQ': return function(data){
                    data = data.detail;

                    var _html = '<div class="detail-info">' +
                                '<p class="info-title">简介</p>' +
                                '<div class="activity-intro info-content">' + data.introduction + '</div>' +   
                                '<p class="info-title">项目背景</p>' +
                                '<div class="detail-backdrop info-content">' + data.backdrop + '</div>';
                        
                        data.creativePictures.length && (_html += '<p class="info-title">图示</p>' + app.getSwiper(data.creativePictures.map(function(img){
                            return app.imgServer + img.url;
                        })));
                        
                        _html += '<p class="info-title">项目需求</p>' +
                                 '<div class="detail-required info-content">' + data.required + '</div>' +
                                 '<p class="info-title">不符合方案</p>' +
                                 '<div class="detail-fallPlan info-content">' + data.fallPlan + '</div>' +
                                 '<p class="info-title">合作方式</p>' +
                                 '<div class="detail-cooperation info-content">' + data.cooperation + '</div>' +
                                 '<p class="info-title">截止日期</p>' +
                                 '<div class="detail-end-date info-content">' + cut(data.endDate) + '</div>';

                        if(data.demand && data.demand.trim()) 
                                _html += '<p class="info-title">方案详细要求</p>' +
                                         '<div class="detail-demand info-content">' + data.demand + '</div>';
                        
                        if(data.field && data.field.trim())
                                _html += '<p class="info-title">可能成功的技术领域</p>' +
                                         '<div class="detail-field info-content">' + data.field + '</div>';

                                 
                        _html += '<p class="info-title">关键字</p>' +
                                 '<div class="detail-keyword info-content" data-value="' + data.keyword　+ '">' + data.keyword + '</div>' +
                                 '</div>';
                    return _html;
                };
                
                // 设计方案 详情
                case 'MK_SJFA': return function(data){
                    data = data.detail;

                    var _html = '<div class="detail-info">' +
                                '<p class="info-title">设计说明</p>' +
                                '<div class="detail-desc info-content">' + helper.addImageServerUrl(data.description) + '</div>' +
                                '<p class="info-title">使用场景</p>' +
                                 '<div class="detail-scene info-content">' + data.scene + '</div>';
                        
                        data.creativePictures.length && (_html += '<p class="info-title">设计方案图示</p>' + app.getSwiper(data.creativePictures.map(function(img){
                            return app.imgServer + img.url;    
                        })));

                        if(data.invovate.trim()) _html += '<p class="info-title">主要创新点</p>' +
                                                          '<div class="detail-invovate info-content">' + data.invovate + '</div>';
                                 
                        _html += '<p class="info-title">产品类别</p>' +
                                 '<div class="detail-productTypeName info-content">' + data.productTypeName + '</div>' +
                                 '<p class="info-title">合作模式</p>' +
                                 '<div class="detail-mode info-content">' + data.cooperationModeName + '</div>' +
                                 '<p class="info-title">知识产权情况</p>' +
                                 '<div class="detail-property info-content">' + data.propertyName + '</div>' +
                                 '<p class="info-title">关键字</p>' +
                                 '<div class="detail-keyword info-content" data-value="' + data.keyword　+ '">' + data.keyword + '</div>' +
                                 '</div>';
                    return _html;
                };

                // 技术方案 详情
                case 'MK_JSFA': return function(data){
                    data = data.detail;
                    var _html = '<div class="detail-info">' +
                                '<p class="info-title">技术说明</p>' +
                                '<div class="detail-desc info-content">' + helper.addImageServerUrl(data.description) + '</div>';
                        
                        data.creativePictures.length && (_html += '<p class="info-title">技术图示</p>' + app.getSwiper(data.creativePictures.map(function(img){
                            return app.imgServer + img.url;
                        })));

                        if(data.invovate.trim()) _html += '<p class="info-title">主要创新点</p>' +
                                                          '<div class="detail-invovate info-content">' + data.invovate + '</div>';
                                 
                        
                        _html += '<p class="info-title">能实现的指标</p>' +
                                 '<div class="detail-target info-content">' + data.target + '</div>' +
                                 '<p class="info-title">使用场景</p>' +
                                 '<div class="detail-scene info-content">' + data.scene + '</div>' +
                                 '<p class="info-title">合作模式</p>' +
                                 '<div class="detail-mode info-content">' + data.cooperationModeName + '</div>' +
                                 '<p class="info-title">成熟度</p>' +
                                 '<div class="detail-mature info-content">' + data.matureName + '</div>' +
                                 '<p class="info-title">知识产权情况</p>' +
                                 '<div class="detail-propertyName info-content">' + data.propertyName + '</div>' +
                                 '<p class="info-title">技术领域</p>' +
                                 '<div class="detail-filed info-content">' + data.fieldName + '</div>';

                        if(data.videoAddress && data.videoAddress.trim())  _html += '<p class="info-title">在线视频播放地址</p>' +
                                                                                    '<div class="detail-videoAddress info-content">' + data.videoAddress + '</div>';
                                  
                        _html += '<p class="info-title">关键字</p>' +
                                 '<div class="detail-keyword info-content" data-value="' + data.keyword　+ '">' + data.keyword + '</div>' +
                                 '</div>';
                    return _html;
                };
                break;

                // 奇思妙想 详情
                case 'MK_QSMX': return function(data){
                    data = data.detail;
                    var _html = '<div class="detail-info">' +
                                '<p class="info-title">创意描述</p>' +
                                '<div class="detail-desc info-content">' + helper.addImageServerUrl(data.description) + '</div>';
                        
                        data.creativePictures.length && (_html += '<p class="info-title">图片</p>' + app.getSwiper(data.creativePictures.map(function(img){
                            return app.imgServer + img.url;
                        })));
                        
                        data.content.trim() && ( _html += '<p class="info-title">补充说明</p>' + '<div class="detail-content info-content">' + data.content + '</div>');
                                 
                        _html += '<p class="info-title">产品类别</p>' +
                                 '<div class="detail-product-type info-content">' + data.productTypeName + '</div>' +
                                 '<p class="info-title">关键字</p>' +
                                 '<div class="detail-keyword info-content" data-value="' + data.keyword　+ '">' + data.keyword + '</div>' +
                                 '</div>';
                    return _html;
                };
                break;
            }
        }

        return new app.page({
            id :  id,
            cls: (cls && cls.trim() ? cls : '')  + ' temp',
            param: {
                type: type,
                code: code
            },
            header:{
                title: type2Title[isMy + '-' + type] + '详情',
                isShare: !helper.isWeChat(),
                dataOf : 'detail-panel',
                cb: function(data){
                    data = data.detail;
                    // 生成分享页: title 标题; desc 描述; img 图片; url 链接
                    app.share({
                        title: data.title,
                        desc : data.introduction ? data.introduction : data.description,
                        img  : data.creativePictures[0].url,
                        url  : baseInfo.url + 'creativityCenter/index.html?pageType=detail&isMy=N' + '&type=' + type + '&code=' + code
                    });
                }
            },
            comment:{
                key: 'detail-comment-page',
                ajaxParam: {
                    url: 'common/saveComment',
                    data: {
                        code: code,
                        type: type
                    }   
                },
                commentListKey: 'detail-comment-section' // 关联评论列表
             },
            content:{
                panel: {
                    cls: 'detail-panel',
                    template : headerHtml,
                    key: 'detail-panel',
                    ajaxParam: {
                        url: 'common/detail',
                        data: {
                            isMy: isMy,
                            type: type,
                            code: code
                        }
                    },
                    cb: function(data, parent){
                        parent.parent('.page').find('nv-star.icon-star').attr('star-status', data.detail.collectionFlag);
                    },
                    tab: {
                        cls: 'detail-tabs',
                        tabOps: getTabOps(type, isMy)
                    },
                },
            },
            nav: {
                cls: 'detail-nav',
                navOp : getNavOps(type),
                dataOf: 'detail-panel',
                cb : function(page, parent, data){

                    parent.find('.nv-zan').attr('zan-status', data.detail.likeFlag);

                    // 超过截止日期
                    if(type === 'MK_CYDS' && new Date() > helper.getDate(data.detail.endDate)){
                        $('#' + page.option.id + ' .nv-idea'  ).addClass('unclickable');
                        $('#' + page.option.id + ' .nv-scheme').addClass('unclickable');
                    }

                    // nav 初始化结束, 初始化事件
                    $(document).off('click', '#' + page.option.id + ' .nv-zan'); 
                    $(document).on ('click', '#' + page.option.id + ' .nv-zan', function(e){

                        if(!isLogin()) return;

                        if($('#' + page.option.id + ' .nv-zan').attr('zan-status') === 'Y') {
                            $.toast('已经点赞过了！');
                            return;
                        }
                        app.ajax({
                            url: 'common/like',
                            data: {
                                code: code,
                                type: type
                            },
                            context: $(e.target),
                            beforeSend: function(){}
                        }, function(data, $this){
                            $this.attr('zan-status', 'Y');
                            $.toast('点赞成功！');
                            var $zan = $('#' + page.option.id + ' .detail-header-zan.icon-zan'),
                                num  = Number($zan.attr('zan-num')) + 1;
                            $zan.text(num).attr('zan-num', num);
                        })
                    });

                    /* 收藏事件 */
                    $(document).off('click', '#' + page.option.id + ' .star-icon');
                    $(document).on ('click', '#' + page.option.id + ' .star-icon', function(e){
                        if(!isLogin()) return;
                        app.ajax({
                                    url: 'common/collection',
                                    data: {
                                        code: code,
                                        type: type
                                    },
                                    context: $(e.target),
                                    beforeSend: function(){}
                                }, function(data, $this){
                                    var _status = ( $this.attr('star-status') === 'Y' ? 'N' : 'Y' );
                                    $this.attr('star-status', _status);
                                    _status === 'Y' ? $.toast('收藏成功！') : $.toast('取消收藏成功！');
                                });
                    });
                }
            }
        });
    }

    function getSchemePublishPage(matchCode, matchTitle, matchType){
        return new app.page({
            id: 'page-scheme-publish',
            cls: 'page-publish temp',
            header: {
                title: '发布方案',
                // hint : '返回数据将不保存 确定返回？' 
            },
            content: {
                tab: {
                    cls: 'tab-scheme',
                    tabOps: [{
                        text: '设计方案',
                        key : 'tab-design',
                        template: designPublish.template,
                        initCb: function(data, parent, page){
                            designPublish.initEvent(page, parent, matchCode, matchTitle, matchType);
                        }
                    },{
                        text: '技术方案',
                        key : 'tab-tech',
                        template: techPublish.template,
                        initCb: function(data, parent, page){
                            techPublish.initEvent(page, parent, matchCode, matchTitle, matchType);
                        }
                    }]
                }
            }
        });
    }

    function getIdeaPublishPage(matchCode, matchTitle, matchType){
        return new app.page({
            id: 'page-idea-publish',
            cls: 'page-publish temp',
            header: {
                title: '发布创意',
                // hint: 
            },
            content: {
                panel: {
                    cls: 'publish-idea',
                    template: ideaPublish.template,
                    cb: function(data, parent, page){
                        ideaPublish.initEvent(page, parent, matchCode, matchTitle, matchType);
                    }
                }
            }
        });
    }

    function getTechPublishPage(matchCode, matchTitle, matchType){
        return new app.page({
            id: 'page-tech-publish',
            cls: 'page-publish temp',
            header: {
                title: '发布技术方案',
                // hint: 
            },
            content: {
                panel: {
                    cls: 'publish-tech',
                    template: techPublish.template,
                    cb: function(data, parent, page){
                        techPublish.initEvent(page, parent, matchCode, matchTitle, matchType);
                    }
                }
            }
        });
    }

    function getDesignPublishPage(matchCode, matchTitle, matchType){
        if(!isLogin()) return; 
        return new app.page({
            id: 'page-design-publish',
            cls: 'page-publish temp',
            header: {
                title: '发布设计方案',
                // hint: 
            },
            content: {
                panel: {
                    cls: 'publish-design',
                    template: designPublish.template,
                    cb: function(data, parent, page){
                        designPublish.initEvent(page, parent, matchCode, matchTitle, matchType);
                    }
                }
            }
        });        
    }

    /* 列表item样式 */
    function getListItems(type){
        if(['MK_CYDS', 'MK_SJXQ', 'MK_JSXQ', 'MK_ZT', 'MK_XQ'].indexOf(type) !== -1) {
            return  function(data){
                        var _html = '';

                        for(var i = 0; i < data.length; i++){
                            _html += '<li class="touchable clearfix li-item-cc" data-title="' + data[i].title 
                                   + '" data-code="' + data[i].code
                                   + '" data-recommend="' + data[i].isRecommend
                                   + '" data-type="' + data[i].type  + '">' +
                                            '<div class="cc-cover-img ft-left">' + 
                                                '<img onerror="imgError(this)" src="' + app.imgServer + data[i].imgUrl + '"/>' +
                                            '</div>' +
                                            '<div class="ft-right">' + 
                                                '<p class="item-title ellipsis">' + data[i].title + '</p>' +
                                                '<p class="item-intro ellipsis">' + data[i].introduction + '</p>' +
                                                '<div class="item-date bottom">' + 
                                                    '<span class="create-date">' + cut(data[i].createDate)   + '</span>' +  
                                                    '<div class="ft-right" style="display: inline-block;" >' +
                                                        '<span class="sp-read-num reads-icon">' + helper.nc(data[i].readCount) + '</span>' + 
                                                        '<span class="sp-comment-num comments-icon">'  + helper.nc(data[i].commentCount) + '</span>' + 
                                                        '<span class="sp-zan-num icon-zan">'  + helper.nc(data[i].likeCount) + '</span>' + 
                                                    '</div>'
                                                '</div>' +
                                            '</div>' +
                                         '</li>';
                        }
                        return _html;
                    };
        } else if(['MK_QSMX', 'MK_JSFA', 'MK_SJFA', 'MK_FA'].indexOf(type) !== -1) {
            return  function(data){
                        var _html = '';

                        for(var i = 0; i < data.length; i++) {
                            _html += '<li class="clearfix touchable li-item-cd" data-title="' + data[i].title 
                                   + '" data-code="' + data[i].code
                                   + '" data-recommend="' + data[i].isRecommend
                                   + '" data-status="' + data[i].status
                                   + '" data-type="' + data[i].type + '">' + 
                                        '<div class="block-left">' + 
                                            '<img class="head-img" onerror="imgError(this)" src="' + app.imgServer + data[i].createUrl + '" alt="" />' +
                                        '</div>' +
                                        '<div class="block-left">' + 
                                            '<p class="idea-title">' + data[i].title + '</p>' +
                                            '<p><span class="idea-name">'  + data[i].createName  + 
                                                '</span><span class="idea-publish-date">' + cut(data[i].createDate) + '</span></p>' +
                                        '</div>' +
                                     '</li>';
                        }
                        return _html;
                    }
        }
    }

    // 日期截断(2016-09-03 00:12:34 -> 2016-09-03)
    function cut(date){
        return date.trim().split(' ')[0];
    }
})