;define(function(require, exports, module){

    require('../public/js/component'); // 加载依赖的js

    $(function(){
        $(document).on('pageAnimationStart', '#page-default', function(e, id, $page){
            new app.page({
                            id : 'page-default',
                            cls: 'temp',
                            header: {
                                title : '我的待办'
                            },
                            content: {
                                List: {
                                    cls: 'task-list-render',
                                    key: 'my-task-list',
                                    ajaxParam: {
                                        url: 'oa/total',
                                        type: 'GET'
                                    },
                                    template: getTaskListItem,
                                    clickFn: function(e){
                                        toApprovalPage($(e.currentTarget).attr('data-type')).go();  // 跳转到审批列表
                                    }
                                }
                            }
                        }).init();
        });

        /* 返回提示 */
        $(document).on('click', '.mback', function(e){
            var $e = $(e.currentTarget);
            if($e.data('hint')) {
                $.confirm($e.data('hint'), function() {
                    $.router.back();
                    backFlag = true;
                });
            } else {
                $.router.back();
                backFlag = true;
            }
        });
    });

    // 我的待办列表template
    function getTaskListItem(data){
        var _html = '';
        
        for(var i=0; i < data.length; i++){
            _html += '<li data-type="' + data[i].formType + '" class="icon-arrow">' + data[i].formTypeName;
             data[i].totalNum && (_html += '<span class="tip-number">' + data[i].totalNum + '</span>');
            _html += '</li>';
        }
        return _html;
    }

    // 审批列表页
    function toApprovalPage(type){
        return new app.page({
                    id : 'page-approval-list',
                    cls: 'temp',
                    header: {
                        title : '待办列表'
                    },
                    content: {
                        List: {
                            cls: 'approval-list-render',
                            key: 'approval-list',
                            ajaxParam: {
                                url: 'oa/list',
                                data: {
                                    p: 0,
                                    s: 10,
                                    formType: type
                                }
                            },
                            template: getApprovalListItem,
                            clickFn: function(e){
                                var $e       = $(e.currentTarget),
                                    codeOdid = (['MK_WJDC', 'MK_CPZC', 'MK_XPSY'].indexOf($e.data('type')) !== -1 ? $e.data('id') : $e.data('code'));

                                toDetailPage($e.data('type'), codeOdid, $e.data('taskid')).go();
                            },
                            isAddmore: true
                        }
                    }
                }).init();
    }

    // 待办列表item
    function getApprovalListItem(data){
        console.log(data);
        var _html = '';
        for(var i = 0; i < data.length; i++){
            _html += '<li data-code="' + data[i].code 
                  + '" data-type="' + data[i].formType 
                  + '" data-id  ="' + data[i].id 
                  + '" data-taskid="' + data[i].taskId + '">' +
                        '<p class="approval-title">' + data[i].title + '</p>' +
                        '<p>' +
                            '<span class="approval-name">' + data[i].userName + '</span>' +
                            '<span class="approval-date">' + data[i].createDate + '</span>' +
                        '</p>' +
                     '</li>';
        }
        return _html;
    }

    // 详情页面
    function toDetailPage(type, codeOrid, taskId){

        var _url,
            _data  = { type : type },
            _type  = type,
            type2Title = {  
                            'MK_CYDS': '创意大赛',
                            'MK_SJXQ': '设计需求',
                            'MK_JSXQ': '技术需求',
                            'MK_SJFA': '设计方案',
                            'MK_JSFA': '技术方案',
                            'MK_QSMX': '奇思妙想',
                            'MK_WJDC': '问卷调查',
                            'MK_CPZC': '产品众筹',
                            'MK_XPSY': '新品试用',
                            }; 

        function getNavOps(type){
            if(['MK_JSFA', 'MK_SJFA', 'MK_QSMX'].indexOf(type) !== -1){
                return [{
                        key  : 'key-nv-deal',
                        liCls: 'nv-li-2-1 task-nv-li',
                        text : '处理',
                        aCls : 'nv-deal',
                        clickFn: function(){
                            toDealPage(taskId, _type).go();
                        }
                    },{
                        key  : 'key-nv-transfer',
                        liCls: 'nv-li-2-1 task-nv-li',
                        text : '转办',
                        aCls : 'nv-cancel red',
                        clickFn: function(){
                            toPickTransfer(taskId).go();
                        }
                    }];
            } else {
                return [{
                        key  : 'key-nv-deal',
                        liCls: 'nv-li-2-1 task-nv-li',
                        text : '处理',
                        aCls : 'nv-deal',
                        clickFn: function(){
                            toDealPage(taskId, _type).go();
                        }
                    },{
                        key  : 'key-nv-transfer',
                        liCls: 'nv-li-2-1 task-nv-li',
                        // text : '转办',
                        text: '取消',
                        aCls : 'nv-cancel red',
                        clickFn: function(){
                            // toPickTransfer(taskId).go();
                            $.router.back();
                        }
                    }];
            }
        }

        switch(type){
 
            case 'MK_SJFA': 
            case 'MK_JSFA': 
            case 'MK_QSMX': 
            case 'MK_CYDS': _data.isOa = 'Y';
            case 'MK_SJXQ': 
            case 'MK_JSXQ':
                            _url = 'common/detail';
                            _data.code = codeOrid;
            break; 
            case 'MK_WJDC': _url = 'question/examList';
                            _data.questionnaireId = codeOrid;
            break; 
            case 'MK_CPZC': _url = 'crowd/approveDetail';
                            _data.id = codeOrid;
            break;
            case 'MK_XPSY': _url = 'product/details';
                            _data.id = codeOrid;
            break;
        }

        return new app.page({
            id : 'page-approval-detail',
            cls: 'temp',
            header: {
                title : type2Title[type] + '详情'
            },
            content: {
                panel: {
                    cls: 'approval-detail-panel',
                    template : getDetailTemplate(type),
                    key: 'approval-detail',
                    ajaxParam: {
                        url : _url,
                        data: _data
                    }
                }
            },
            nav: {
                cls: 'approval-nav',
                navOp : getNavOps(type)
            },
            cb: function(parent, page){
            }
        }).init();
    }

    // 处理页面
    function toDealPage(taskId, type){

        var type2Title = { MK_CYDS: '创意大赛审批', 
                           MK_SJXQ: '设计需求审批',
                           MK_JSXQ: '技术需求审批',
                           MK_SJFA: '设计方案评审', 
                           MK_JSFA: '技术方案评审', 
                           MK_QSMX: '奇思妙想评审', 
                           MK_XPSY: '新品试用审批', 
                           MK_CPZC: '产品众筹审批', 
                           MK_WJDC: '问卷调查审批'};

        var isCustom = ['MK_QSMX', 'MK_JSFA', 'MK_SJFA'].indexOf(type) !== -1; // 判断是否是用户发布的奇思妙想，设计方案，技术方案
         
        return new app.page({
                        id : 'page-approval-deal',
                        cls: 'temp',
                        header: {
                            title : type2Title[type]
                        },
                        content: {
                            panel: {
                                cls: 'approval-detail-panel',
                                template : function(){
                                    return '<table class="deal-table">' +
                                                '<tr>' +
                                                    '<td>处理结果</td>' +
                                                    '<td>' +
                                                        '<input class="deal-ip" type="radio" name="approval-result" value="Y" id="ip-ar-y"/>' + 
                                                        '<label for="ip-ar-y">' + (isCustom ? '采纳' : '同意') + '</label>' +
                                                        '<input class="deal-ip" type="radio" name="approval-result" value="N" id="ip-ar-n"/>' +
                                                        '<label for="ip-ar-n">' + (isCustom ? '不采纳' : '不同意') + '</label>' +
                                                    '</td>' +
                                                '</tr>' +
                                                '<tr class="tr-range" style="display: none;">' +
                                                    '<td>评价等级</td>' +
                                                    '<td>' +
                                                        '<input class="deal-ip" type="radio" name="approval-range" value="1" id="ip-ar-m"/>' + 
                                                        '<label for="ip-ar-m">中</label>' +
                                                        '<input class="deal-ip" type="radio" name="approval-range" value="2" id="ip-ar-g"/>' +
                                                        '<label for="ip-ar-g">良</label>' +
                                                        '<input class="deal-ip" type="radio" name="approval-range" value="3" id="ip-ar-p"/>' +
                                                        '<label for="ip-ar-p">优</label>' +
                                                    '</td>' +
                                                '</tr>' +
                                                '<tr class="tr-open"  style="display: none;">' +
                                                    '<td>是否公开</td>' +
                                                    '<td>' +
                                                        '<input class="deal-ip" type="radio" name="approval-open" value="Y" id="ip-ao-o"/>' + 
                                                        '<label for="ip-ao-o">公开</label>' +
                                                        '<input class="deal-ip" type="radio" name="approval-open" value="N" id="ip-ao-s">' +
                                                        '<label for="ip-ao-s">保密</label>' +
                                                    '</td>' +
                                                '</tr>' +
                                                '<tr>' +
                                                    '<td>处理意见</td>' +
                                                    '<td>' +
                                                        '<textarea name="deal-suggestion" id="txt-suggestion" ' +
                                                            'placeholder="请输入处理意见 不超过200字" maxlength="200" cols="30" rows="7"></textarea>' +
                                                    '</td>' +
                                                '</tr>' +
                                            '</table>';
                                },
                                cb: function(data, parent, page){
                                    if(isCustom){
                                        var currentPageId = page.option.id;

                                        $('#' + currentPageId + ' .tr-range').show();
                                        $('#' + currentPageId + ' .tr-open').show();

                                        $('#' + currentPageId + ' input[name="approval-result"]').on('click', function(e){
                                            $(e.currentTarget).val() === 'Y' ? $('#' + currentPageId + ' .tr-range').show()
                                                                             : $('#' + currentPageId + ' .tr-range').hide();

                                        });
                                    }
                                }
                            }
                        },
                        nav: {
                            cls: '',
                            navOp: [{
                                        key  : 'key-nv-deal',
                                        liCls: 'nv-li-2-1 task-nv-li',
                                        text : '提交',
                                        aCls : 'nv-deal',
                                        clickFn: function(){
                                            var param = {
                                                taskId : taskId,
                                                comment: $('.page-current #txt-suggestion').val(),
                                                status : $('.page-current input[name="approval-result"]:checked').val()
                                            };

                                            isCustom && (param.grade  = $('.page-current input[name="approval-range"]:checked').val())
                                                     && (param.isOpen = $('.page-current input[name="approval-open"]:checked').val());

                                            if(!param.comment.trim()){

                                                $.alert("请输入处理意见！");

                                            } else if(isCustom && !param.grade){

                                                $.alert("请选择评价等级！");

                                            } else if(isCustom && !param.isOpen){

                                                $.alert("请选是否公开！");

                                            } else {

                                                $.confirm('确定提交审批结果?', function(){
                                                    app.ajax({
                                                        url: 'oa/approve',
                                                        data: param
                                                    }, function(){
                                                        $.alert('提交成功', function(){
                                                            app.pageGroup['page-approval-list'].components['approval-list'].refresh();
                                                            app.back('page-approval-list');
                                                        });
                                                    });
                                                });
                                                    
                                            }
                                        }
                                    },{
                                        key  : 'key-nv-deal-cancel',
                                        liCls: 'nv-li-2-1 task-nv-li',
                                        text : '取消',
                                        aCls : 'nv-deal red',
                                        clickFn: function(){
                                            $.alert('取消将不保存意见 确定取消吗', function(){
                                                app.back(-1);
                                            });
                                        }
                                    }]
                        }
                    }).init();
    }

    // 组织架构
    function toPickTransfer(taskId, id /* 组织id */){
        var _data = {};

        id && (_data.id = id);

        return new app.page({
                    id : 'page-org-list',
                    cls: 'temp',
                    header: {
                        title : '组织架构'
                    },
                    content: {
                        List: {
                            cls: 'org-list-render',
                            key: 'org-list',
                            ajaxParam: {
                                url: 'oa/organs',
                                data: _data
                            },
                            template: getOrgTemplate,
                            clickFn: function(e){
                                var $e = $(e.currentTarget);
                                if($e.data('select') !== 'Y') {
                                    toPickTransfer(taskId, $e.data('id')).go();
                                } else {
                                    toTransferPage(taskId, $e.data('name'), $e.data('id')).go();
                                }
                            }
                        }
                    }
                }).init();       
    }
    
    // 组织架构template
    function getOrgTemplate(data){
        var _html = '';

        for(var i = 0; i < data.length; i++){
            _html += '<li data-name="' + data[i].name  + 
                     '" data-select="' + data[i].isSelect  + 
                     '" data-id="' + data[i].id + '" '  + 
                     (data[i].isSelect !== 'Y' ? ' class="icon-arrow"' : '') + '>' + data[i].name + '</li>';
        }
        return _html;
    }

    // 转办页面
    function toTransferPage(taskId, name, id){
        return new app.page({
                    id : 'page-transfer',
                    cls: 'temp',
                    header: {
                        title : '转办处理'
                    },
                    content: {
                        panel: {
                                cls: 'transfer-panel',
                                dataOf: 'tranfer-list',
                                ajaxParam: {
                                    url: 'common/list',
                                    data: {
                                        p: 0,
                                        s: 10,
                                        type : 'MK_QSMX'
                                    }
                                },
                                template : function(data){
                                    return '<table class="deal-table">' +
                                                '<tr>' +
                                                    '<td>转办人</td>' +
                                                    '<td>' +
                                                        '<span>' + name + '</span>' +
                                                    '</td>' +
                                                '</tr>' +
                                                '<tr>' +
                                                    '<td>处理意见</td>' +
                                                    '<td>' +
                                                        '<textarea name="deal-suggestion" id="txt-suggestion" ' +
                                                            'placeholder="请输入处理意见 不超过200字"  maxlength="200" cols="30" rows="7"></textarea>' +
                                                    '</td>' +
                                                '</tr>' +
                                            '</table>';
                                }
                            }
                    },
                    nav: {
                        cls: '',
                        navOp: [{
                                key  : 'key-nv-transfer-submit',
                                liCls: 'nv-li-2-1 task-nv-li',
                                text : '提交',
                                aCls : 'nv-transfer-submit',
                                clickFn: function(){
                                    if($('#txt-suggestion').val().trim()){
                                        app.ajax({
                                            url: 'oa/turn',
                                            data: {
                                                taskId: taskId,
                                                turnPerson: ',' + id + ',', // 方便龙磊后台查询数据
                                                turnOpinion: $('#txt-suggestion').val()
                                            }
                                        }, function(data){
                                            if(data.detail) $.alert('转办成功', function(){
                                                app.pageGroup['page-approval-list'].components['approval-list'].refresh();
                                                app.back('page-approval-list');
                                            });
                                        })
                                    } else {
                                        $.alert('请输入处理意见！');
                                    }
                                }
                            },{
                                key  : 'key-nv-transfer-cancel',
                                liCls: 'nv-li-2-1 task-nv-li',
                                text : '取消',
                                aCls : 'nv-transfer-cancel red',
                                clickFn: function(){
                                    $.alert('取消将不保存意见 确定取消吗?', function(){
                                        app.back('page-approval-detail');
                                    });
                                }
                            }]
                    }
                }).init();       
    }

    // 详情页面
    function getDetailTemplate(type){
        console.log('获取模板：',type);


        // 转办信息
        function getTranformInfo(data){
            var _hml =  '<p class="info-title">审批意见</p>' +
                        '<div class="detail-tranforminfo info-content">' +
                        '<table>' +
                        '<thead>' +
                            '<td>经办人</td>' +
                            '<td>时间</td>' +
                            '<td>意见</td>' +
                        '</thead>';

            _hml += '<tr>' + 
                        '<td>' + data.operatorName + '</td>' +
                        '<td>' + data.submitDate   + '</td>' +
                        '<td>' + data.examine      + '</td>' +
                    '</tr>';

            var list = data.hitcommentVoList;
            for(var i = 0; i < list.length; i++){
                _hml += '<tr>' + 
                            '<td>' + list[i].headlerName + '</td>' +
                            '<td>' + list[i].handlerDate + '</td>' +
                            '<td>' + list[i].handOpinion + '</td>' +
                        '</tr>';
            }
            _hml += '</table></div>';
            return _hml;
        }

        switch(type){
            // 创意大赛 详情
            case 'MK_CYDS': return function(data){
                data = data.detail;
                var _html = '<h4 class="detail-title">' + data.title + '</h4>' +
                            '<p class="detail-basic-info">' +
                                '<span>' + data.createName +'</span>' +
                                '<span>' + cut(data.createDate) + '</span>' +
                            '</p>' +
                            '<div class="detail-info">' +
                                '<p class="info-title">活动描述</p>' +
                                '<div class="activity-desc info-content">' + helper.addImageServerUrl(data.description) + '</div>' +
                                '<p class="info-title">首页图片</p>' +
                                '<div class="activity-home-img info-content"><img src="' + app.imgServer + data.imgUrl + '" alt="" /></div>';

                    data.creativePictures.length && (_html += '<p class="info-title">图片</p>' + app.getSwiper(data.creativePictures.map(function(img){
                        return app.imgServer + img.url;
                    })));
            
                    _html += '<p class="info-title">赛程安排</p>' +
                                '<div class="detail-arrange info-content">' + data.arrange + '</div>' +
                                '<p class="info-title">奖项设置</p>' +
                                '<div class="detail-prize info-content">' + data.setup + '</div>' +
                                '<p class="info-title">评选标准</p>' +
                                '<div class="detail-eval info-content">' + data.standard + '</div>' +
                                '<p class="info-title">截止时间</p>' +
                                '<div class="detail-closing-date info-content">' + data.endDate + '</div>' +
                            '</div>';
                return _html;
            };
            // 设计需求 详情
            case 'MK_SJXQ': return function(data){
                data = data.detail;

                var _html = '<h4 class="detail-title">' + data.title + '</h4>' +
                            '<p class="detail-basic-info">' +
                                '<span>' + data.createName +'</span>' +
                                '<span>' + cut(data.createDate) + '</span>' +
                            '</p>' +
                            '<div class="detail-info">' +
                            '<p class="info-title">需求描述</p>' +
                            '<div class="detail-desc info-content">' + helper.addImageServerUrl(data.description) + '</div>' +
                            '<p class="info-title">背景描述</p>' +
                            '<div class="detail-backdrop info-content">' + data.backdrop + '</div>';
                            '<p class="info-title">首页图片</p>' +
                            '<div class="activity-home-img info-content"><img src="' + app.imgServer + data.imgUrl + '" alt="" /></div>';
                    data.creativePictures.length && (_html += '<p class="info-title">图片</p>' + app.getSwiper(data.creativePictures.map(function(img){
                        return app.imgServer + img.url;
                    })));
                    _html += '<p class="info-title">产品类别</p>' +
                             '<div class="detail-type-name info-content">' + data.productTypeName + '</div>' +
                             '<p class="info-title">关键字</p>' +
                             '<div class="detail-keyword info-content">' + data.keyword + '</div>' +
                             '</div>';
                return _html;
            };
             
            // 技术需求 详情
            case 'MK_JSXQ': return function(data){
                data = data.detail;

                var _html = '<h4 class="detail-title">' + data.title + '</h4>' +
                            '<p class="detail-basic-info">' +
                                '<span>' + data.createName +'</span>' +
                                '<span>' + cut(data.createDate) + '</span>' +
                            '</p>' +
                            '<div class="detail-info">' +
                            '<p class="info-title">项目背景</p>' +
                            '<div class="detail-backdrop info-content">' + data.backdrop + '</div>';
                            '<p class="info-title">首页图片</p>' +
                            '<div class="activity-home-img info-content"><img src="' + app.imgServer + data.imgUrl + '" alt="" /></div>';
                    
                    data.creativePictures.length && (_html += '<p class="info-title">图示</p>' + app.getSwiper(data.creativePictures.map(function(img){
                        return app.imgServer + img.url;
                    })));
                    
                    _html += '<p class="info-title">项目需求</p>' +
                             '<div class="detail-required info-content">' + data.required + '</div>' +
                             '<p class="info-title">不符合方案</p>' +
                             '<div class="detail-fallPlan info-content">' + data.fallPlan + '</div>' +
                             '<p class="info-title">合作方式</p>' +
                             '<div class="detail-cooperation info-content">' + data.cooperation + '</div>' +
                             '<p class="info-title">截止日期</p>' +
                             '<div class="detail-end-date info-content">' + cut(data.endDate) + '</div>' +
                             '<p class="info-title">方案详细要求</p>' +
                             '<div class="detail-demand info-content">' + data.demand + '</div>' +
                             '<p class="info-title">可能成功的技术领域</p>' +
                             '<div class="detail-field info-content">' + data.field + '</div>' +
                             '<p class="info-title">关键字</p>' +
                             '<div class="detail-keyword info-content">' + data.keyword + '</div>' +
                             '</div>';

                return _html;
            };
            
            // 设计方案 详情
            case 'MK_SJFA': return function(data){
                data = data.detail;

                var _html = '<h4 class="detail-title">' + data.title + '</h4>' +
                            '<p class="detail-basic-info">' +
                                '<span>' + data.createName + '</span>' +
                                '<span>' + cut(data.createDate) + '</span>' +
                            '</p>' +
                            '<div class="detail-info">' +
                            '<p class="info-title">设计说明</p>' +
                            '<div class="detail-desc info-content">' + helper.addImageServerUrl(data.description) + '</div>' +
                            '<p class="info-title">使用场景</p>' +
                            '<div class="detail-scene info-content">' + data.scene + '</div>';
                        
                    data.creativePictures.length && (_html += '<p class="info-title">设计方案图示</p>' + app.getSwiper(data.creativePictures.map(function(img){
                        return app.imgServer + img.url;    
                    })));

                    if(data.invovate.trim()) _html += '<p class="info-title">主要创新点</p>' +
                                                      '<div class="detail-invovate info-content">' + data.invovate + '</div>';
                             
                    
                    _html += '<p class="info-title">产品类别</p>' +
                             '<div class="detail-productTypeName info-content">' + data.productTypeName + '</div>' +
                             '<p class="info-title">合作模式</p>' +
                             '<div class="detail-mode info-content">' + data.cooperationModeName + '</div>' +
                             '<p class="info-title">知识产权情况</p>' +
                             '<div class="detail-property info-content">' + data.propertyName + '</div>' +
                             '<p class="info-title">关键字</p>' +
                             '<div class="detail-keyword info-content">' + data.keyword + '</div>' +
                             '</div>';

                    data.operatorName.trim() && (_html += getTranformInfo(data));


                return _html;
            };

            // 技术方案 详情
            case 'MK_JSFA': return function(data){
                data = data.detail;
                var _html = '<h4 class="detail-title">' + data.title + '</h4>' +
                            '<p class="detail-basic-info">' +
                                '<span>' + data.createName +'</span>' +
                                '<span>' + cut(data.createDate) + '</span>' +
                            '</p>' +
                            '<div class="detail-info">' +
                            '<p class="info-title">技术说明</p>' +
                            '<div class="detail-desc info-content">' + helper.addImageServerUrl(data.description) + '</div>';
                    
                    data.creativePictures.length && (_html += '<p class="info-title">技术图示</p>' + app.getSwiper(data.creativePictures.map(function(img){
                        return app.imgServer + img.url;
                    })));
                    
                    
                    if(data.invovate.trim()) _html += '<p class="info-title">主要创新点</p>' +
                                                      '<div class="detail-invovate info-content">' + data.invovate + '</div>';
                             

                    _html += '<p class="info-title">能实现的指标</p>' +
                             '<div class="detail-target info-content">' + data.target + '</div>' +
                             '<p class="info-title">使用场景</p>' +
                             '<div class="detail-scene info-content">' + data.scene + '</div>' +
                             '<p class="info-title">合作模式</p>' +
                             '<div class="detail-mode info-content">' + data.cooperationModeName + '</div>' +
                             '<p class="info-title">成熟度</p>' +
                             '<div class="detail-mature info-content">' + data.matureName + '</div>' +
                             '<p class="info-title">知识产权情况</p>' +
                             '<div class="detail-propertyName info-content">' + data.propertyName + '</div>' +
                             '<p class="info-title">技术领域</p>' +
                             '<div class="detail-filed info-content">' + data.fieldName + '</div>' +
                             '<p class="info-title">在线视频播放地址</p>' +
                             '<div class="detail-video info-content">' + data.videoAddress + '</div>' +
                             '<p class="info-title">关键字</p>' +
                             '<div class="detail-keyword info-content">' + data.keyword + '</div>' +
                             '</div>';
                    data.operatorName.trim() && (_html += getTranformInfo(data));

                return _html;
            };

            // 奇思妙想 详情
            case 'MK_QSMX': return function(data){
                data = data.detail;
                var _html = '<h4 class="detail-title">' + data.title + '</h4>' +
                            '<p class="detail-basic-info">' +
                                '<span>' + data.createName +'</span>' +
                                '<span>' + cut(data.createDate) + '</span>' +
                            '</p>' +
                            '<div class="detail-info">' +
                            '<p class="info-title">创意描述</p>' +
                            '<div class="detail-desc info-content">' + helper.addImageServerUrl(data.description) + '</div>';
                    
                    data.creativePictures.length && (_html += '<p class="info-title">图片</p>' + app.getSwiper(data.creativePictures.map(function(img){
                        return app.imgServer + img.url;
                    })));
                    _html += '<p class="info-title">补充说明</p>' +
                             '<div class="detail-content info-content">' + data.content + '</div>' +
                             '<p class="info-title">产品类别</p>' +
                             '<div class="detail-product-type info-content">' + data.productTypeName + '</div>' +
                             '<p class="info-title">关键字</p>' +
                             '<div class="detail-keyword info-content">' + data.keyword + '</div>' +
                             '</div>';
                        
                    data.operatorName.trim() && (_html += getTranformInfo(data));
               
                return _html;
            };

            // 问卷调查
            case 'MK_WJDC': return function(data){

                var _html = '';

                data = data.list;

                for(var i = 0; i < data.length; i++){

                    var _htm      = '',
                        questionId = data[i].id, 
                        type       = data[i].typeCode ;  // TMLX_DANX为单选

                    // 填空
                    if(type === "TMLX_TK"){
                        _htm += '<ul>' +
                                    '<li>' + 
                                        '<textarea readonly id="titleDetails"  class="titleDetails" cols="50" rows="6" name="' + questionId + '"></textarea>' + 
                                   '</li>' +
                                 '</ul>';
                    // 单选选项
                    } else if (type === "TMLX_DANX"){

                        _htm += '<ul class="ul-raido">';
                        
                        for(var j = 0; j < data[i].choice.length; j++){
                            _htm += '<li>' +
                                        '<span class="radio_box">' +
                                            '<input disabled type="radio" name="' + questionId + '" id="radio_' + questionId + j + '" value="' + data[i].choice[j].id + '">' +
                                            '<label for="radio_' + questionId + j + '"></label>' +
                                            '<em>' + data[i].choice[j].description + '</em>' +
                                        '</span>' +
                                    '</li>';
                        }
                        _htm += '</ul>';

                    // 多选选项
                    } else if (type === "TMLX_DUOX") {

                        _htm += '<ul class="ul-option">';
                        
                        for(var j = 0; j < data[i].choice.length; j++){
                            _htm += '<li>' +
                                        '<span class="check_box">' +
                                        '<input disabled type="checkbox" name="' + questionId + '" id="checkbox_' + questionId + j + '" value="' + data[i].choice[j].id + '">' +
                                        '<label for="checkbox_' + questionId + j + '"></label>' +
                                        '<em>' + data[i].choice[j].description + '</em>' +
                                        '</span>' +
                                    '</li>';
                        }
                        _htm += '</ul>';
                    }
                    _html += '<div class="survey-answer" data-id=' + questionId + '>' +
                                '<span class="ans">' + (i + 1) + '. ' + data[i].description + '</span>' +
                                 _htm +
                             '</div>';
                };
                return _html;
            };

            // 产品众筹
            case 'MK_CPZC': return function(data){
                data = data.list[0];

                // 回报表单
                function getTable(repays){
                    var _htm = '<table>' +
                                    '<thead>' +
                                        '<td>支持金额</td>' +
                                        '<td>名额</td>' +
                                        '<td>回报内容</td>' +
                                    '</thead>';
                    for(var i = 0; i < repays.length; i++){
                        _htm += '<tr>' + 
                                    '<td>' + repays[i].price + '</td>' +
                                    '<td>' + (repays[i].quota == 0 ? '不限' : repays[i].quota) + '</td>' +
                                    '<td>' + repays[i].content + '</td>' +
                                '</tr>';
                    }
                    _htm += '</table>';

                    return _htm;
                }

                var _html = '<h4 class="detail-title">' + data.title + '</h4>' +
                            '<p class="detail-basic-info">' +
                                '<span>' + data.createName +'</span>' +
                                '<span>' + cut(data.createTime) + '</span>' +
                            '</p>' +
                            '<div class="detail-info">' +
                            '<p class="info-title">产品类别</p>' +
                            '<div class="detail-product-type info-content">' + data.productName + '</div>' +
                            '<p class="info-title">项目名称</p>' +
                            '<div class="detail-title info-content">' + data.title + '</div>' +
                            '<p class="info-title">截止时间</p>' +
                            '<div class="detail-days info-content">' + data.trialDate + '</div>' +
                            '<p class="info-title">众筹金额</p>' +
                            '<div class="detail-amount info-content">' + data.amount + '</div>' +
                            '<p class="info-title">项目概括</p>' +
                            '<div class="detail-summarize info-content">' + data.summarize + '</div>' +
                            '<p class="info-title">项目图片</p>' +
                            '<div class="detail-images info-content">' + 
                                app.getSwiper(data.pictures.map(function(pic){
                                    return app.imgServer + pic.url;
                                }))  + 
                            '</div>' +
                            '<p class="info-title">项目介绍</p>' +
                            '<div class="detail-description info-content">' + helper.addImageServerUrl(window.unescape(data.description)) + '</div>';

                if(data.ideaName && data.ideaName.trim()) _html += '<p class="info-title">关联的创意</p>' +
                                                                   '<div class="detail-ideaName info-content" data-code="' + data.ideaCode + '">' + data.ideaName + '</div>';

                if(data.techniqueName && data.techniqueName.trim()) _html += '<p class="info-title">关联的方案</p>' +
                                                                             '<div class="detail-technique-name info-content" data-code="' + data.techniqueCode + '">' + data.techniqueName + '</div>';
                            
                    _html += '<p class="info-title">回报</p>' +
                             '<div class="detail-heldprice info-content">' + getTable(data.repays) + '</div>' +
                             '</div>';
                return _html;
            };

            // 新品试用
            case 'MK_XPSY': return function(data){
                data = data.list[0];

                var _html = '<h4 class="detail-title">' + data.name + '</h4>' +
                            '<p class="detail-basic-info">' +
                                '<span>' + data.createName +'</span>' +
                                '<span>' + cut(data.createDate) + '</span>' +
                            '</p>' +
                            '<div class="detail-info">' +
                            '<p class="info-title">产品SAP码</p>' +
                            '<div class="detail-sap info-content">' + data.sap + '</div>' +
                            '<p class="info-title">产品图片</p>' +
                            '<div class="detail-url info-content">' +
                                app.getSwiper(data.pictures.map(function(pic){
                                    return app.imgServer + pic.url;
                                })) + 
                            '</div>' +
                            '<p class="info-title">产品概述</p>' +
                            '<div class="detail-description info-content">' + helper.addImageServerUrl(data.description) + '</div>' +
                            '<p class="info-title">新品详情</p>' +
                            '<div class="detail-details info-content">' + helper.addImageServerUrl(window.unescape(data.details)) + '</div>' +
                            '<p class="info-title">市场参考价</p>' +
                            '<div class="detail-price info-content">' + data.price + '</div>' +
                            '<p class="info-title">试用名额</p>' +
                            '<div class="detail-quota info-content">' + data.quota + '</div>' +
                            '<p class="info-title">申请人数上限</p>' +
                            '<div class="detail-upper info-content">' + data.upper + '</div>' +
                            '<p class="info-title">活动截止申请时间</p>' +
                            '<div class="detail-applyDate info-content">' + data.applyDate + '</div>' +
                            '<p class="info-title">滞留积分</p>' +
                            '<div class="detail-heldScore info-content">' + data.heldScore + '</div>' +
                            '<p class="info-title">滞留金额</p>' +
                            '<div class="detail-heldprice info-content">' + data.heldPrice + '</div>' +
                            '<p class="info-title">产品试用是否回收</p>' +
                            '<div class="detail-recover info-content">' + (data.recover === 'Y' ? '是' : '否') + '</div>' +
                            '</div>';
                return _html;
            };
        }
    }

    // 日期截断(2016-09-03 00:12:34 -> 2016-09-03)
    function cut(date){
        return date.trim().split(' ')[0];
    }
});