/*
*
* @author: acejerry
* @date  : 2016-9-23
* @function: 创意中心组件
*
*/
;define(function(require, exports, module){
	(function(app){

	   !app && (app = new Object());

		/* 全局变量 */
		app.pageCode = 0;                                   // 页面编码：用于页面id值冲突的时候
	   !app.pageGroup && (app.pageGroup = new Object());    // 保存page对象

		/* Ajax请求：successFn请求成功之后的回调函数 */
		app.ajax = function(param, successFn){


			// 默认ajax参数
			var defaultParam = {
	            type   : 'POST',
	            timeout: 30000 ,
	            success: function (data) {
	                if(data.status) {
	                	$('.me-modal-text').remove();
	                	successFn && successFn(data, this);
	                } else if(data.errorCode === '505') {
	                	$('.me-modal-text').remove();
	            		$.confirm('用户还未登录 请先登录', function(){
	            			window.toLoginPage();
	            		})
	                } else {
	                	$('.me-modal-text').html('<p class="error-tip">' + data.errorMessage + '</p>');
	                }
	            },
	            error: function (xhr, type) {
	                $.toast('请求异常 请检查网络');
	            },
	            beforeSend: function(xhr, settings) {
	                $.showIndicator();
	            },
	            complete: function (xhr, status) {
	            	$.hideIndicator();
	            	$.hidePreloader();
	            }
	        };
	        var _param = $.extend({}, defaultParam, param, true);

	        _param.url = app.server + _param.url;

	        // 转换成jsonparm格式
	        JSON.stringify(_param.data) ? _param.data = {jsonparm : JSON.stringify(_param.data)} : _param.data = {};

	        // console.log('请求参数:', _param.data, _param.data.jsonparm.length);
	        
	        $.ajax(_param);
		};

		/* swiper图片 */
		app.getSwiper = function(images){
	        var _html =  '<div class="swiper-container" data-space-between="10" ><div class="swiper-wrapper">';

	        images.forEach(function(img, index){
	            _html += '<div class="swiper-slide"><img onerror="imgError(this)" data-index="' + index + '" src="' + img + '" alt=""></div>';
	        });
	        
	        _html += '</div>' +
	                 '<div class="swiper-pagination"></div>' +
	                 '</div>';
	        return _html;
	    };

		/* 选项列表 */
		app.chooseList = function(title, dicType, role, trigger, cb){

			!$('.modal-overlay').size() && $('body').append('<div class="modal-overlay"></div>');

			var _html = '<div class="choose-list" role="' + role + '" style="display: none;">' +
							'<p class="choose-list-title">' + title +(role === 'list-select' ? '(可多选)' : '') + '</p>' +
							'<ul>' +
								'<div class="inner-preloader"><div class="preloader"></div></div>' +
							'</ul>' +
							(role === 'list-select' ? '<p class="choose-list-sure touchable">确定</p>' : '') +
						'</div>';

			var $chooseList = $('body').append(_html).children('.choose-list').eq(-1);

			app.ajax({
					url: 'common/querySubDic',
					data: {
						dicType: dicType
					},
					beforeSend: function(){}
				}, function(data) {
					
					data = data.list;

					var _html = '';
			
					for(var i = 0; i < data.length; i++) {
						_html += '<li class="choose-item" data-key="' + data[i].dicKey + '" data-value="' + data[i].dicValue + '">' +
								 	data[i].dicValue +
								 '</li>';
					}
					$chooseList.css('min-height', 'auto').children('ul').html(_html);
				});
			// 单选列表
			$chooseList.off('click', '[role="list-radio"] .choose-item');
			$chooseList.on ('click', '[role="list-radio"] .choose-item', function(e){
				var $e  = $(e.target),
					val = $e.data('value'),
					key = $e.data('key');

				$e.siblings().removeClass('choosed');
				$e.addClass('choosed');

				setTimeout(function(){
					$e.parents('.choose-list').hide();
					$('.modal-overlay').removeClass('modal-overlay-visible choose-list-overlay');
					cb(key, val);
				}, 100);
			});

			// 多选列表
			$chooseList.off('click', '[role="list-select"] .choose-item');
			$chooseList.on ('click', '[role="list-select"] .choose-item', function(e){
				$(e.target).toggleClass('pre-checked');
				$(e.target).toggleClass('choosed');
			});

			// 多选列表 确定
			$chooseList.off('click', '.choose-list-sure');
			$chooseList.on ('click', '.choose-list-sure', function(e){
				
				var values = new Array(),
					$p     = $(e.target).parents('.choose-list');
				$p.find('li.choosed').forEach(function(i){
					values.push({
						key  : $(i).data('key'),
						value: $(i).data('value')
					});
				});

				setTimeout(function(){
					$p.hide();
					$p.find('li').removeClass('pre-checked');
					$('.modal-overlay').removeClass('modal-overlay-visible choose-list-overlay');
					cb(values);
				}, 100);	
			});

			$('body').off('click', '.choose-list-overlay.modal-overlay');
			$('body').on ('click', '.choose-list-overlay.modal-overlay', function(){
				$('.choose-list').hide();
				$('.modal-overlay').removeClass('modal-overlay-visible choose-list-overlay');
				$('.choose-list').find('li.pre-checked').toggleClass('choosed pre-checked');
			});

			$('body').off('click', trigger);
			$('body').on ('click', trigger, function(e){
				$('.modal-overlay').addClass('modal-overlay-visible choose-list-overlay');
				$chooseList.show();
			});
		};
		
		/* 评论 */
		app.comment = function(page, parent, option/* ajaxParam, commentList */){
			this.page   = page;
			this.parent = parent;
			this.key    = option.key;  
			this.commentListKey = option.commentListKey;
			this.ajaxParam      = option.ajaxParam;

			this.key && (this.page.components[this.key] = this);
		};
		app.comment.prototype.init = function(){

			var self = this;
			
			if(self.parent.find('.popup.popup-comment').size() === 0) {
				
				var _html = '<div class="popup popup-comment" data-popup="open-comment">' +
				  				'<div class="content-block">' +
				  					'<div class="comment-container">' + 
				  						'<textarea rows="3" placeholder="请输入评论内容"></textarea>' +
				  						'<p>' + 
				  							'<a class="ft-right comment-submit">发表</a>' +
				  						'</p>' +
				  					'</div>' +
				  				'</div>' +
							'</div>' +
							'<div class="popup-overlay"></div>';
		        self.parent.append(_html);

		        self.initEvent();
			}
	        return self;
		};
		app.comment.prototype.initEvent = function(){
			var self = this;

	        // 点击遮罩层 隐藏
	        $(document).on('click', '#' + self.page.option.id + ' div.overlay-comment', function(){
	        	self.hide();
	        });

	        // 检测输入框非空
	        $(document).on('input', '#' + self.page.option.id +  ' .comment-container textarea', function(e){
	        	if($(e.target).val()){
	        		$('.comment-submit').addClass('clickable');
	        	} else {
	        		$('.comment-submit').removeClass('clickable');
	        	}
	        });

			// 提交评论
	        $(document).off('click', '#' + self.page.option.id + ' .comment-submit.clickable');
	        $(document).on ('click', '#' + self.page.option.id + ' .comment-submit.clickable', function(e){

	        	// 如果是回复评论 需要传被回复的评论id值superId
	        	self.superId ? self.ajaxParam.data.superId = self.superId 
	        	             : ('superId' in self.ajaxParam.data && delete self.ajaxParam.data.superId);

	        	self.ajaxParam.data.content = $(e.target).parent().siblings('textarea').val();

	        	// 修改按键状态
	        	self.ajaxParam.beforeSend   = function(){
	        		self.parent.find('.comment-submit.clickable').removeClass('clickable').addClass('submiting').text('提交中');
	        	}; 

	        	app.ajax(self.ajaxParam, function(data){
	   				self.hide();
	      		 	self.page.components[self.commentListKey].refresh();
	      		 	$.toast('评论成功！');

	      		 	// 设置顶部评论数
	      		 	var $comment = $('#' + self.page.option.id + ' .detail-header-comment'),
	      		 	    _num     = Number($comment.attr('comment-num'));
	      		 	$comment.size() && $comment.attr('comment-num', _num + 1).text(_num + 1);

	      		 	// 更新页面评论数
	      		 	$('[data-code="' + self.ajaxParam.data.code + '"] .comments-icon').html(helper.nc(_num + 1));

	        	});
	        });
		};
		app.comment.prototype.show = function(commentListKey, superId){
			this.commentListKey = commentListKey;
			this.superId        = superId;
	      		 	
	      	$('#' + this.page.option.id + ' .comment-submit').text('发表');
	    	$('.popup-overlay').addClass('modal-overlay-visible overlay-comment');
			$('.popup-comment').removeClass('modal-out').addClass('modal-in').show();
		};
		app.comment.prototype.hide = function(){
		    $('.popup-comment').addClass('modal-out');
	    	$('.overlay-comment.popup-overlay').removeClass('modal-overlay-visible overlay-comment');
	    	$('.comment-container textarea').val('');
	    	$('.comment-submit').removeClass('clickable');
		};

		/* 评论列表 */
		app.commentSection = function(page, parent, option/* key, type, code, commentPageKey */){
			this.page   = page;
			this.parent = parent;
			this.key    = option.key; // 这里是列表的key
			this.cls    = option.cls;
			this.ajaxParam 	    = option.ajaxParam;
			this.commentPageKey = option.commentPageKey;

			this.key && (this.page.components[this.key] = this);
		};
		app.commentSection.prototype.init = function(cb){
			var self = this;
			
			self.parent.append('<div class="section-' + self.cls + '">' +
									'<p class="comment-title">全部评论</p>' +
									'<div class="comment-list-part"></div>' +
								'</div>');

			self.commentList = new app.List(self.page, self.parent.find('.comment-list-part'), {
												cls      : self.cls,
												ajaxParam: self.ajaxParam,
												template : app.commentListItems,
												clickFn  : undefined,
												isAddmore: true
											}).init(cb);

			// 显示评论页
	        $(document).off('click', '#' + self.page.option.id + ' a.open-comment-reply');
	        $(document).on ('click', '#' + self.page.option.id + ' a.open-comment-reply', function(e){
	        	if(isLogin()){
	        		self.page.components[self.commentPageKey]                  // 通过关联的评论页面的key 显示评论页
	        			.show(self.key, $(e.target).parents('li').data('id')); // 传参：评论列表key 关联此评论的id值
	        	}
	        });

			return self;
		};
		app.commentSection.prototype.refresh = function(){
			this.commentList.refresh({
				p: 0,
				beforeSend: undefined
			});
		};
		app.commentListItems = function(data){
			var _html = '';

			for(var i = 0; i < data.length; i++) {
				
				_html += '<li class="clearfix" data-id="' + data[i].currentComment.id + '">' + 
						 	'<div class="block-left">' + 
						 		'<img class="head-img"  onerror="imgError(this)" src="' + app.imgServer + data[i].currentComment.url + '"/>' +
						 	'</div>' +
						 	'<div class="block-right">' + 
						 		'<div class="clearfix comment-info">' + 
							 		'<div class="block-left">' + 
							 			'<span class="commenter-name">' + data[i].currentComment.createName + '</span>' +
						 				'<span class="comment-date">' + helper.timeConverter(data[i].currentComment.createDate) + '</span>' +
							 		'</div>' +
							 		'<a class="comments-icon ft-right open-comment-reply"></a>' +
						 		'</div>' +
							 	'<p class="comment-content">' + data[i].currentComment.content + '</p>';
				
				if(data[i].parentComment){
					_html += '<div class="comment-reply-to">' +
						 		'<p class="rely-to-info">' +
						 			'<span class="reply-commenter-name">' + data[i].parentComment.createName + '</span>' +
						 			'<span class="reply-comment-date">' + helper.timeConverter(data[i].parentComment.createDate) + '</span>' +
						 		'</p>' +
						 		'<p class="reply-to-content">' + data[i].parentComment.content + '</p>' +
						 	 '</div>';
				}

				_html += '</div></li>';
			}

			return _html;
		};

		/* 列表 */
		app.List = function(page, parent, option/*cls, ajaxParam, template, clickFn, isAddmore*/){
			this.parent  = parent;
			this.page    = page;
			this.cls 	 = option.cls;
			this.key     = option.key;
			this.clickFn = option.clickFn;
			this.ajaxParam = option.ajaxParam;
			this.template  = option.template;
			this.isAddmore = option.isAddmore;

			this.key && (this.page.components[this.key] = this);
		};
		app.List.prototype.init = function(cb){

			var self = this;

			app.ajax(self.ajaxParam, function(data){

				var _html = '';
				_html += '<div class="container-' + self.cls + '">' + 
							 '<ul class="' + self.cls + '">' + 
							 	 self.template(data.list) + 
							 '</ul>';
				
				if(self.isAddmore && data.list.length === self.ajaxParam.data.s) _html += '<p class="addmore" status="more-data">查看更多</p>';

				_html += '</div>';

				self.parent.append(_html);
				
				// 容器
				self.container = $('#' + self.page.option.id + ' .container-' + self.cls.split(' ').join());

				helper.ifNoData(data) && self.container.html('<div class="no-data"></div><p></p>');
				// 初始化时间
				self.initEvent();

				// 回调函数
				cb && cb();
			});

			return self;
		};
		app.List.prototype.initEvent = function(){
			
			var self = this;

			$(document).off('click',  '#' + self.page.option.id + ' .' + self.cls.split(' ').join('.') + ' li');
			$(document).on ('click',  '#' + self.page.option.id + ' .' + self.cls.split(' ').join('.') + ' li', function(e){
				self.clickFn && self.clickFn(e);
			});

			// 查看更多的事件
			if(self.isAddmore){

				$(document).off('click', '#' + self.page.option.id + ' .' + self.parent[0].classList[0] + ' [status="more-data"].addmore');
				$(document).on ('click', '#' + self.page.option.id + ' .' + self.parent[0].classList[0] + ' [status="more-data"].addmore', function(){

					var _param = $.extend({}, self.ajaxParam, {
									beforeSend: function(){
										self.container.find('.addmore')
													  .attr('status', 'loading')
													  .html('<div class="preloader"></div>');
								 	}
								}, true);

					_param.data.p++;

					app.ajax(_param, function(data){

						self.ajaxParam.data.p++;
						data = data.list;					

						$('#' + self.page.option.id + ' .' + self.cls.split(' ').join('.')).append(self.template(data));
						data.length === self.ajaxParam.data.s ? $('#' + self.page.option.id + ' .' + self.parent[0].classList[0] + ' .addmore').attr('status', 'more-data').html('查看更多') 
						          							  : $('#' + self.page.option.id + ' .' + self.parent[0].classList[0] + ' .addmore').attr('status', 'no-more-data').html('暂无更多数据');
					});

				});
			}	
		};
		app.List.prototype.refresh = function(paramData){
			var self = this;
				
			var _paramData = $.extend({}, self.ajaxParam.data, paramData, {p: 0}, true),
				_param = $.extend({}, self.ajaxParam, {data: _paramData}, true);

			app.ajax(_param, function(data){

				var _html = '';
				_html += '<div class="container-' + self.cls + '">' + 
							 '<ul class="' + self.cls + '">' + 
							 	 self.template(data.list) + 
							 '</ul>';
				
				if(self.isAddmore && data.length === self.ajaxParam.data.s) _html += '<p class="addmore touchable" status="more-data">查看更多</p>';

				_html += '</div>';

				self.parent = $('#' + self.page.option.id + ' .' + Array.prototype.join.call(self.parent[0].classList, '.'));
				self.parent.html(_html); console.log(self.parent);
				
				// 容器
				self.container = self.parent.find(' .container-' + self.cls);

				helper.ifNoData(data) && self.container.html('<div class="no-data"></div><p></p>');
				
				// 初始化时间
				self.initEvent();
				self.ajaxParam.data = _paramData;
			});
		};

		/* 页面 */
		app.page = function(option){
			this.option = option;
			this.components = new Object();
		};

		app.page.prototype.init = function(cb){
			// 微信模式：添加class，wechat-mode
			// var wechatCls = helper.isWeChat() ? ' wechat-mode ' : ''; 
			var wechatCls = '';

			// page-default 进入该模块时候的默认页id值
			if(this.option.id !== 'page-default') {
				$('div.page-group  #' + this.option.id).size() && (this.option.id += app.pageCode++); // 避免页面id值重复
				$('div.page-group').append('<div class="page ' + (!this.option.cls ? '' : this.option.cls) + wechatCls + '" id="' + this.option.id + '"></div>');
			} else {
				if(!$('#page-default').size()) $('.page-group').append('<div class="page" id="page-default" ></div>');
				$('#page-default').html('').addClass(wechatCls);
				this.option.cls && $('#page-default').addClass(this.option.cls);
			}
			// 初始化组件
			for(i in this.option) {
				if(app[i]){
					new app[i](this, $('div.page-group  #' + this.option.id), this.option[i]).init();
				}
			}
			this.option.cb && this.option.cb();   // 回调函数

			app.pageGroup[this.option.id] = this; // id值对应page对象

			return this;
		};


		app.page.prototype.go   = function(ignoreCache){
			$.router.load('#' + this.option.id, ignoreCache);
		};
		app.page.prototype.show = function(){
			$('.page-group .page').removeClass('page-current');
			$('#' + this.option.id).addClass('page-current');
		};

		/* 头部 */
		app.header = function(page/* page对象 */, parent /* 父元素$对象 */, option/* title:标题; isBack:是否返回; hint:返回的提示信息; isCollect:收藏标签 */){
			this.page   = page;
			this.parent = parent;
			this.title  = option.title;
			this.isBack = (option.isBack !== false ? true : false); // 默认带返回
			this.hint   = option.hint;
			this.cb     = option.cb;
			this.dataOf = option.dataOf;
			this.isShare= option.isShare;
			this.alist  = option.alist;
		};
		app.header.prototype.init = function(){

			// 设置标题
			// $('title').text(this.title);

			// 在微信端 不需要显示header 
			// if(this.parent.hasClass('wechat-mode')) {
			// 	return;
			// }
			var _html = '<header class="bar bar-nav">',
				self  = this;

			// 是否需要回退图标
			if(self.isBack && app.pageIdCache.length > 0){
				 // _html += '<a class="icon icon-left pull-left back" ' 
					//     + (!this.hint ? '' : 'data-hint="' + this.hint + '"') + '></a>';
				_html += '<a class="button button-link button-nav pull-left back"><span class="icon icon-left"></span></a>';
			}
			// 是否需要分享图标
			if(self.isShare) {
				 _html += '<a class="nv-share open-share icon ft-right"></a>';
			}

			if(self.alist) {
				self.alist.forEach(function(al){
					_html += '<a class="' + al.cls + '">' + al.text + '</a>';
				});
			}

			_html += '<h1 class="title">' + self.title + '</h1></header>';
	  		
	  		self.parent.append(_html);

	  		self.cb && (self.dataOf ? helper.once(function(){
	  											  // 判断依赖的数据是否已经请求到
	  											  return self.page.components[self.dataOf].data;
	  										 }, function(){
	  											  self.cb(self.page.components[self.dataOf].data);
	  										 })
	  										 : self.cb());

	  		return self;
		};

		/* 内容区 */
		app.content = function(page, parent, option){
			this.option = option;
			this.parent = parent;
			this.page   = page;
		};
		app.content.prototype.init = function(){

			var $content = this.parent.children('.content');
			
			!$content.size() && ($content = this.parent.append('<div class="content"></div>').children('.content'));

			for(i in this.option){
				if(app[i]){
					new app[i](this.page, $content, this.option[i]).init();
				}
			}
		};

		/* 搜索 */
		app.search = function(page, parent, option /* renderComponent 关联组件 */){
			this.page   = page;
			this.parent = parent; 
			this.renderKey = option.renderKey;
		};
		app.search.prototype.init = function(){
			var self = this;

			var _html = '<div class="bar bar-header-secondary">' +
			               '<div class="searchbar">' +
			                 '<div class="search-input">' +
			                   '<input type="search" class="search" placeholder="输入标题"/>' +
			                   '<a href="" class="a-search">搜索</a>' +
			                 '</div>' +
			               '</div>' +
			            '</div>';
			this.parent.append(_html);

			/* 事件监听 */
			$(document).off('tap', '#' + self.page.option.id + ' .a-search');
			$(document).on ('tap', '#' + self.page.option.id + ' .a-search', function(){
				self.page.components[self.renderKey].refresh({
																p: 0, // 设置为第0页
																title: self.parent.find('.search').val()
															});
			});

			return this;
		};

		/* Panel */
		app.panel = function(page, parent, option/* cls template */) {
			this.page   = page;
			this.parent = parent;
			this.option = option;
			this.cls    = option.cls;
			this.key    = option.key; 
			this.template  = option.template;
			this.cb     = option.cb;
			this.ajaxParam = option.ajaxParam;

			this.key && (this.page.components[this.key] = this);
		};
		app.panel.prototype.init = function(){
			var self = this;


			if(self.ajaxParam){
				app.ajax(self.ajaxParam, function(data){
				
					self.parent.append('<div class="' + self.cls + '">' + self.template(data) + '</div>');

					self.data = data; // 保存数据

					for(i in self.option){
						if(app[i]){
							new app[i](self.page, self.parent.find('.' + self.cls), self.option[i]).init(self.option[i].cb);
						}
					}
					self.cb && self.cb(self.data, self.parent, self.page);
				});
			} else {
				self.parent.append('<div class="' + self.cls + '">' + self.template(data) + '</div>');
				for(i in self.option){
					if(app[i]){
						new app[i](self.page, self.parent.find('.' + self.cls), self.option[i]).init(self.option[i].cb);
					}
				}
				self.cb && self.cb(self.data, self.parent, self.page);
			}
		};
		
		/* tab */
		app.tab = function(page, parent, option /* cls tabOps */){
			this.page   = page;
			this.parent = parent;
			this.key    = option.key;
			this.tabOps = option.tabOps;
		};
		app.tab.prototype.init = function(){

			var self    = this,
				_tabOps = self.tabOps;

			var _html = '<div class="div-tabs ' + (self.key ? self.key : '') + '" data-offset="44">';

			for(var i = 0; i < _tabOps.length; i++) {
				_html += '<span class="sp-tab tab-' + _tabOps.length + (i !== 0 ? ' "' : ' active"') + ' data-key="' + _tabOps[i].key + '">' + 
							'<a href="">' +  _tabOps[i].text +  '</a>' +
						 '</span>';
			}
			_html += '</div><div class="tab-contents">';


			for(var i = 0; i < _tabOps.length; i++) {
				_html += '<div class=' + _tabOps[i].key + '-content tab-content' + (i !== 0 ? ' style="display: none;" ' : '') + ' data-status="unloaded"></div>';
			}
			_html += '</div>';

			self.parent.append(_html);

			// 默认加载第一个tab内容
			var $content = self.parent.find('.' + _tabOps[0].key + '-content');

			var i = _tabOps[0];
			if(i.dataOf){
				$content.mhtml(self.page.components[i.dataOf].data, 
							   i.template(self.page.components[i.dataOf].data, $content, self.page));

				i.initCb && i.initCb(self.page.components[i.dataOf].data, $content, self.page);
			} else if(i.ajaxParam){
				app.ajax(i.ajaxParam, function(data){
					   		$content.mhtml(data, i.template(data, $content, self.page));
				
							i.initCb && i.initCb(data, $content, self.page);
					    });
			} else if(i.template){
				$content.mhtml(true, i.template(undefined, $content, self.page));
				i.initCb && i.initCb(true, $content, self.page);
			}
			$content.attr('data-status', 'loaded');

			// 保存当前tab的key值：避免重复点击的重复加载
			self.currentTab = _tabOps[0].key;
			
			self.initEvent();
			return self;
		};
		app.tab.prototype.initEvent = function(){
			
			var self  = this;

			/* tab 点击事件 */
			$(document).off('click', '#' + self.page.option.id + ' .sp-tab');
			$(document).on ('click', '#' + self.page.option.id + ' .sp-tab', function(e){

				var key = $(e.currentTarget).data('key');
				if(self.currentTab !== key){
					var $content = $('#' + self.page.option.id + ' .' + key + '-content');

					self.tabOps.forEach(function(i){
						if(i.key === key) {
							if($content.data('status') === 'unloaded'){
								// 公用之前组件请求过的数据
								if(i.dataOf){
									$content.mhtml(self.page.components[i.dataOf].data, 
												   i.template(self.page.components[i.dataOf].data, $content, self.page));

									i.initCb && i.initCb(self.page.components[i.dataOf].data, $content, self.page); 
								} else if(i.ajaxParam){
									app.ajax(i.ajaxParam, function(data){
										   		$content.mhtml(data, i.template(data, $content, self.page));
												i.initCb && i.initCb(data, $content, self.page);
										    });
								} else if(i.template){
									var _temp = i.template(undefined, $content, self.page);
									if(_temp) $content.html(_temp);
									i.initCb && i.initCb(true, $content, self.page);
								}
								$content.attr('data-status', 'loaded');
							}
						}
					});

					$(e.currentTarget).addClass('active').siblings().removeClass('active');
					$content.siblings().hide();
					$content.show();
					self.currentTab = key;

					self.tabOps.forEach(function(i){
						i.key === key && i.clickCb && i.clickCb(); // 切换tab时的回调函数
					});
				}
			});
		};

		app.tab.prototype.refresh = function(){
			this.init();
		};

		/* nav */
		app.nav = function(page, parent, option){
			this.page   = page;
			this.parent = parent;
			this.navOp  = option.navOp;
			this.cls    = option.cls;
			this.cb     = option.cb;
			this.dataOf = option.dataOf;
		};
		app.nav.prototype.init = function(){
			var self  = this;

			var _html = '<nav class="nav-bottom ' + this.cls + '"><ul class="nv-ul">';

			self.navOp.forEach(function(op){
				_html += '<li class="' + op.liCls + '" data-key="' + op.key + '">' + 
							'<a ' + (!op.href ? '' : 'href="' + op.href + '"') + (!op.aCls ? '' : ' class="' + op.aCls + '"')
								  + (op.popup ? 'data-popup="' + op.popup + '" ' : '') + '>' 
								  + (!op.text ? '' : op.text) + 
							'</a>' +
						 '</li>';
			});
			_html += '</ul></nav>';

			/* 重新设置 content区的高度 如果是微信端 不需要header 重新调整高度 */
			// helper.isWeChat() ? self.parent.children('.content').height($(window).height() - 44)
			self.parent.children('.content').height($(window).height() - 88);


			self.parent.append(_html);

			/* 点击事件 监听 */
			$(document).off('click', '#' + self.page.option.id + ' .nv-ul li');
			$(document).on ('click', '#' + self.page.option.id + ' .nv-ul li', function(e){
				var key = $(e.currentTarget).data('key');
				self.navOp.forEach(function(op){
					if(key === op.key){
						op.clickFn && op.clickFn(e, self);
					}
				});
			});
			console.log('nav组件初始化中...');
			if(self.cb){
				// 是否依赖其它组件数据
				self.dataOf ? helper.once(function(){
								  // 判断依赖的数据是否已经请求到
								  return self.page.components[self.dataOf].data;
							  }, function(){
								  self.cb(self.page, self.parent.children('.' + self.cls), self.page.components[self.dataOf].data);
							  })
							: self.cb(self.page, self.parent.children('.' + self.cls));
			}
			
			return self;
		};

		/* 加载中... */
		app.loading = function($self) {
			return $self.append('<div class="me-modal-text modal-text"><div class="preloader"></div></div>');
		};
		app.loaded = function($self) {
			return $self.children('div.me-modal-text').remove();
		};
		
		/* 下拉刷新 */
		app.pullToRefresh = function($content, target/* 刷新对象的选择器 */, refreshFn/* 刷新回调函数 */, distance/* 下拉的距离 */){
			
			// 如果已经存在下拉刷新组件 直接返回
			if($content.hasClass('pull-to-refresh-content')) return;

			// 默认的下拉刷新层
			var _html = '<div class="pull-to-refresh-layer">' +
							'<div class="preloader"></div>' +
	    					'<div class="pull-to-refresh-arrow"></div>' +
	        			'</div>';

			$content.addClass('pull-to-refresh-content').prepend(_html);
	        
			distance && $content.attr('data-ptr-distance', distance);
	        
	        // 初始化才能用
	        $.initPullToRefresh('.content');

			// 添加'refresh'监听事件
			$content.off('refresh');
			$content.on ('refresh', function(e) {

				// 刷新回调函数
				refreshFn($content.find(target));
					
				// 更新查看更多
				$content.find('.addmore').size() && $content.find('.addmore').attr('status', 'more-data').text('查看更多');
				$('#search').size()  && $('#search').val('');

			    // 结束下拉刷新
			    $.pullToRefreshDone('.pull-to-refresh-content');
			});
		};

		/* 服务器地址配置 */
		app.server = baseInfo.apiUrl;
		/* 图片地址 */
		app.imgServer = baseInfo.imgUrl;

		window.app = app;
	})(window.app);
});