/*
* app端消息推送调用原生能力，需要由原生代理请求。ios，android
* app端上传头像相册，摄像头，需要压缩
* 微信端图片上传，压缩
* 全局的登录信息
* 业务接口请求限制
* */

;define(function(require, exports, module){

    if(!window.baseInfo) window.baseInfo = {};

    /*本地环境地址*/
    //baseInfo.apiUrl = 'http://demo.coracle.com:18180/JMAPP/api/v1/'; //测试环境
    baseInfo.apiUrl = 'http://120.77.56.137:18180/JMAPP/api/v1/'; //uat
    //baseInfo.apiUrl = 'http://172.18.91.156:8080/sample-mxm-web/api/v1/'; //龙磊
    //baseInfo.apiUrl = 'http://172.18.91.115:8080/api/v1/'; //龙磊
    // baseInfo.apiUrl = 'http://172.18.91.149/JMAPP/api/v1/'; //宋文锦
    //baseInfo.apiUrl = 'http://172.18.91.187:8080/JMAPP/api/v1/'; //刘川
    
    /* 图片地址 */
    //baseInfo.imgUrl = 'http://demo.coracle.com:18180/JMAPP'; //测试环境
    baseInfo.imgUrl = 'http://120.77.56.137:18180/JMAPP'; // uat
    //baseInfo.imgUrl = 'http://172.18.91.156:8080/sample-mxm-web';  // 龙磊
    // baseInfo.imgUrl = 'http://172.18.91.187:8080/JMAPP';  // 刘川
    // baseInfo.imgUrl = 'http://172.18.91.149/JMAPP/';      // 宋文锦

    /* 服务器文件路径 */
    // baseInfo.url = 'http://demo.coracle.com:18180/JMAPP/HTML5/';    // 测试文件路径
    baseInfo.url = 'http://120.77.56.137:18180/JMAPP/HTML5/'; // UAT文件路径

    !window.app && (window.app = new Object());
    !app.userInfo && (app.userInfo = JSON.parse(window.localStorage.getItem('userInfo'))); 

    /*
    *
    * userInfo:
    *  1.status: true/false
    *  2.phone : 手机
    *  3.role  : 角色
    * 
    */
    
    /*需要验证登录信息的业务接口配置*/
    var apiItem = [
        'crowd/saveCollection',  // 众筹/新品试用，收藏
        'product/likes',         // 众筹/新品，喜欢
        'newestInfo/addComment', // 新闻资讯，新增评论
        'newestInfo/addZan',     // 新闻资讯，点赞
        'community/applyMaster', // 版主申请
        'community/submitTopic', // 提交新增话题
        'community/addComment',  // 话题-新增评论
        'community/like',        // 话题-点赞
        'score/myRanking',       // 积分榜
        'score/myScore',         // 积分商城
        'member/detailInfo',     // 我的
        'product/employees',     // 获取人员信息
        'product/saveComment',   // 新品试用-详情-保存评论
        'product/saveReports',   // 新品试用-提交试用报告
        'alipay/topay',          // 支付接口
        'product/saveCollection',// 新品试用-收藏
        'product/cancelCollection',  // 新品试用-取消收藏
        'crowd/saveCollection',      // 众筹-收藏
        'crowd/cancelCollection',    // 众筹-取消收藏
        'crowd/save',                // 众筹-保存评论
        'product/likes',             // 新品试用-点赞
        'crowd/likes',               // 众筹-点赞
        'crowd/apply',               // 众筹-生成订单
        'product/save',              // 新品试用-提交试用申请
    ];

    /* 检查接口 判断是否需要登录及是否登录过 如果没有返回false 并跳转到登录页面 */
    window.validateApi = function(apis){

        app.userInfo = JSON.parse(window.localStorage.getItem('userInfo'));


        if(apiItem.indexOf(apis) !== -1 && !(app.userInfo && app.userInfo.status)){
            $.confirm('您还没登录 请先登录',function(){
                toLoginPage();
            });
            return false;
        }
        return true;
    };


    /* 手动检测是否登录 如果没有跳到登录页 返回false */
    window.isLogin = function(){
        app.userInfo = JSON.parse(window.localStorage.getItem('userInfo'));

        if(app.userInfo && app.userInfo.status) return true;
        $.confirm('您还没登录 请先登录',function(){
            toLoginPage();
        });
        return false;
    }

    window.toLoginPage = function(){
        require.async(['../../login/login.css', '../../login/login'], function(){
            $.router.load('../login/login.html');
        });
    }
    // 登录操作：传入登录参数
    window.goLogin = function(loginInfo){
        var device = 'wechat'; // 登陆不需要原生态
        switch(device){
            case 'wechat': jomooAjax({
                                apiLast: 'login',
                                params: {
                                    userName: loginInfo.account,
                                    password: loginInfo.password,
                                    remember: true
                                },
                                success: function (data) {
                                    if (!data || !data.detail) {
                                        $.toast('登录异常');
                                    } else if (!data.detail.status) {
                                        $.toast(data.detail.msg);
                                    } else {
                                        // 登录成功之后将值保存在全局的app.userInfo变量中
                                        app.userInfo = data.detail.detail;
                                        app.userInfo.status = 'Y';
                                        window.localStorage.setItem('userInfo' , JSON.stringify(app.userInfo));

                                        // 登录成功之后触发loginSuccess事件
                                        $(document).trigger('loginSuccess'); 
                                        $.router.back();
                                    }
                                }
                           });
            break;
            case 'iphone':  window.loginCb = function(info){
                                alert(info);
                            };
                            var param = {
                                sCallback : "loginCb",
                                userName: userInfo.account,
                                password: userInfo.password,
                                remember: true
                            }
                            window.location.href = 'http://login(' + JSON.stringify(param) + ')';
            break;
            case 'android': alert('调用android接口');
            break;
        }
    }

    /* 设备类型  */
    window.getDeviceType = function(){
        if(navigator.userAgent.match(/iphone/i))                return 'iphone' ; // 苹果
        else if(navigator.userAgent.match(/android/i))          return 'android'; // 安卓
        else if(!!navigator.userAgent.match(/micromessenger/i)) return 'wechat' ; // 微信
    }

    /* 分享 */
    window.goShare = function(param){
        /*       
        *  app.shareOp : title 标题; desc 描述; img 图片; url 链接
        */
        switch(getDeviceType()){
            case 'iphone': window.shareCb = function(info){
                                var _info = JSON.parse(info);
                                // 分享成功
                                if(_info.status == 0) {
                                    addScore();
                                    $.toast('分享成功');

                                } else {
                                    $.toast('分享取消');
                                }
                           };
                           // 朋友圈
                           var _param = {
                                sCallback : 'shareCb',
                                kLinkURL  : param.url ? param.url : window.location.href,
                                thumbData : param.img,
                                kLinkTitle: encodeURI(param.title),
                                kLinkDescription: encodeURI(param.desc),
                                wxScence  : param.scence === 'friends' ? 0 : 1
                           };
                           window.location.href = 'http://wxShare(' + JSON.stringify(param) + ')';
            break;

            case 'android': window.fCallback = function(){
                                $.toast('分享取消');
                            }
                            window.sCallback = function(){
                                addScore();
                                $.toast('分享成功');
                            }
                            window.KndFunc && window.KndFunc.wxShare && window.KndFunc.wxShare(JSON.stringify({
                                type       : 'webpage',
                                webpageUrl : param.url ? param.url : window.location.href,
                                title      : param.title,
                                description: param.desc,
                                thumbData  : baseInfo.imgUrl + param.img,
                                sCallback  : 'sCallback',
                                fCallback  : 'fCallback',
                                appId      : 'wx86206b76255d2004', 
                                scence     : param.scence === 'friends' ? 'WXSceneSession' : 'WXSceneTimeline'
                            }));
            break;
        };
    };

    // 微信端 分享配置
    window.wxShare = function(param){
        $.ajax({
            type   : 'GET',
            url    : baseInfo.apiUrl + 'common/share',
            data   : {jsUrl: window.location.href.split('#')[0]},
            success: function(data){
                data = data.ticket;

                require.async(['http://res.wx.qq.com/open/js/jweixin-1.0.0.js'], function(wx){
                    wx.config({
                        // debug: true,            // 开启调试模式,调用的所有api的返回值会在客户端alert出来，若要查看传入的参数，可以在pc端打开，参数信息会通过log打出，仅在pc端时才会打印。
                        appId: data.appId,         // 必填，公众号的唯一标识
                        timestamp: data.timestamp, // 必填，生成签名的时间戳
                        nonceStr : data.nonceStr,  // 必填，生成签名的随机串
                        signature: data.signature, // 必填，签名
                        jsApiList: [               // 必填，需要使用的JS接口列表，所有JS接口列表见附录2
                            'onMenuShareTimeline',
                            'onMenuShareAppMessage'
                        ]
                    });
                    wx.ready(function(){
                        wx.onMenuShareTimeline({
                                title  : param.title,                   // 分享标题
                                link   : param.url,                     // 分享链接
                                imgUrl : baseInfo.imgUrl + param.img,   // 分享图标
                                success: function () { 
                                    // 用户确认分享后执行的回调函数
                                    addScore();
                                },
                                cancel: function () { 
                                    // 用户取消分享后执行的回调函数
                                    $.toast('分享取消');
                                }
                            });
                        wx.onMenuShareAppMessage({
                                title  : param.title,                   // 分享标题
                                desc   : param.desc,                    // 分享描述
                                link   : param.url,                     // 分享链接
                                imgUrl : baseInfo.imgUrl + param.img,   // 分享图标
                                success: function () { 
                                    // 用户确认分享后执行的回调函数
                                    addScore();
                                },
                                cancel: function () { 
                                    // 用户取消分享后执行的回调函数
                                    $.toast('分享取消');
                                }
                            });
                    });
                });
            }
        });
    };
    // 分享成功之后 添加积分
    function addScore(){
        $.ajax({
            type: 'GET',
            url : baseInfo.apiUrl + 'common/addScore',
            success: function(data){
                if(data.status){
                    console.log('分享成功 获得积分');
                }
            }
        })
    }
});