/**
 * Created by Sa on 2016-09-21.
 */
if(!baseInfo)
    var baseInfo = {};
$(function(){
    'use strict';

    !window.app && (window.app = new Object());
    !app.pageIdCache && (app.pageIdCache = new Array()); // 缓存页面id值

    /*屏幕高度,宽度*/
    baseInfo.windowHeight = $(window).height();
    baseInfo.windowWidth = $(window).width();

    /*翻页*/
    baseInfo.pageIndex = 0;
    baseInfo.pageCount = 10;
    /*没有数据时按钮显示的字样*/
    baseInfo.noMoreTips = '已显示所有数据！';

    var pageIndex,pageCount;
    window.nextPage = function(param){
        /*
         * 需要分页的容器
         * 分页的页面必须指定containerId
         * 容器中新增input保存页码
         * 每次请求从input中获取页码信息
         */
        var containerId    = param.containerId
            ,pageContainer = $('#'+containerId)
            ,btnLoadMore   = pageContainer.find('input[data-event="next-page"]')
            //,isLoadFlag  = pageContainer.find('div.load-more span').attr('data-page-none');
            ,isLoadFlag    = param.thisClick.attr('data-page-none');

        if(isLoadFlag != 'false'){

            /*发送请求时显示加载框*/
            $.showIndicator();

            if(btnLoadMore.length > 0){
                /*获取分页信息*/
                var p = btnLoadMore.attr('data-index')
                    ,s = btnLoadMore.attr('data-count');
                /*点击翻页按钮后更新页码信息*/
                pageIndex = ++p;
                pageCount = s;
                btnLoadMore.attr('data-index',pageIndex)
                    .attr('data-count',pageCount);
            }else{
                /*在初始化的模块中，添加页码信息*/
                /*默认已经加载了第一页的数据，而分页的数据是从页码0开始的，所以点击触发的分页页码从1开始*/
                pageIndex = 1;
                pageCount = baseInfo.pageCount;
                pageContainer.prepend('<input data-event="next-page" type="hidden" data-index="'+pageIndex+'" data-count="'+pageCount+'"/>');
            }
            //return {p:pageIndex,s:pageCount};

            /*请求数据*/
            jomooAjax({
                apiLast:param.apiLast,
                params: $.extend({p:pageIndex,s:pageCount},param.params),
                beforeSend:function(xhr,setting){
                    /*如果没有数据就停止请求，return false*/
                    //if(isLoadFlag == 'false'){
                    //    return false;
                    //}
                    if(typeof param.beforeSend == 'function'){
                        param.beforeSend(xhr,setting);
                    }
                },
                success:function(data){
                    if(typeof param.success == 'function'){
                        param.success(data);
                    }

                    /*判断当前请求是否已经没有数据*/
                    if(!data || data.list.length==0)return;

                    var dataTotal = data.list[0].count;
                    console.log(dataTotal,pageIndex);
                    if(dataTotal == pageIndex*pageCount+data.list.length){
                        /*返回的数据条数小于每页默认的数量时，说明当前为最后一页*/
                        param.thisClick.attr('data-page-none',false);
                        param.thisClick.text('已显示所有数据！')
                            .addClass('no-more');
                    }
                },
                complete:function(){
                    $.hideIndicator();
                }
            });
        }
    };

    /*页面控件*/
    baseInfo.createAreaInfo = function(data){

        var html = '',router='';

        for(var i in data ){
            router = (data[i].router == '#'|| data[i].router == undefined) ? 'javascript:void(0)' : data[i].router;
            html += '<a class="icon-link c-title" href="'+router+'" data-type="'+data[i].type+'" data-id="'+(data[i].id||'')+'">';
            html += '<span class="'+data[i].clsName+'"></span>';
            html += data[i].title;
            //html += (data[i].router==''||data[i].router=='#')?'<span></span>':'<span class="icon icon-right"></span>';
            html += (router == 'javascript:void(0)' && data[i].router !== undefined) ? '<span></span>' : '<span class="icon icon-right"></span>';
            html += '</a>';
            // html += data[i].content||"暂无数据";
            html += data[i].content||"";
        }
        return html;
    };

    /*重写一级页签，根据传值来遍历页签数*/
    baseInfo.createPageTag = function(data){

        var html = ''
            ,pageIndex = ''
            ,pageKey = data.pageKey
            ,pageName = data.pageName
            ,pageContent = data.pageContent;

        html += '<div class="buttons-tab">';
        for(var i=0;i<pageKey.length;i++){
            var //randomNum = baseInfo.getRandom(20)
                cls = (i==0)?'active':''  //默认选中的样式
                ,separate = (i==pageKey.length-1)?'':'<i class="separate-line"></i>'; /*页签分隔线*/


            /*页签*/
            html += '<a href="#'+pageKey[i]+'" class="tab-link '+cls+' button">'+pageName[i]+separate+'</a>';
            /*页签链接到区块*/
            pageIndex += '<div id="'+pageKey[i]+'" class="tab '+cls+'">';
            pageIndex += '<div class="content-block">';
            pageIndex += pageContent[i];
            pageIndex += '</div>';
            pageIndex += '</div>';
        }
        html += '</div>'; //页签结束

        html = html+'<div class="content-block"><div class="tabs">'+pageIndex+'</div></div>';

        return html;
    };

    /* 当前页暂时没有数据 */
    baseInfo.nodata = function(contaier/* $ 选择器 */){
        $(contaier).html('<div class="no-data"></div><p></p>');
    };

    /*单选事件*/
    $(document).on('click','.radio-items',function(e){
        var radio = $(e.currentTarget);
        radio.find('.radio-check').toggleClass('radio-checked');
        radio.siblings('li').find('.radio-check').removeClass('radio-checked');
    });
    
    /*单选事件-性别*/
    $(document).on('click','.sex-check .radio-check',function(e){
        console.log('sex choose');
        var radio = $(e.currentTarget);
        if(radio.hasClass('readonly'))return;
        radio.toggleClass('radio-checked')
            .siblings('.radio-check').removeClass('radio-checked');
    });
    
    /*选择支付方式*/
    $(document).on('click','.payment-method p .radio-check',function(e){
        var _this = $(e.currentTarget);
        _this.toggleClass('radio-checked');
        _this.parent().siblings().find('.radio-check').removeClass('radio-checked');
    });

    /*多选事件*/
    $(document).on('click','.radio-items,.read-me',function(e){
        var checkbox = $(e.currentTarget).find('.checkbox-check')
            ,bottomBtn = checkbox.parents('.content').find('span.btn-bottom');
        checkbox.toggleClass('checkbox-checked');
        /*如果选中了协议项，该页面的'下一步'功能类将被激活*/
        if(bottomBtn.length>0){
            bottomBtn.toggleClass('next-btn');
        }
    });

    /* 列表点击效果 */
    $(document).on('touchstart', 'li.touchable', function(e){
        var $e = $(e.currentTarget);
        $e.css('background-color', 'rgba(250, 250, 250, 0.8)');
    });

    $(document).on('touchend', 'li.touchable', function(e){
        var $e = $(e.currentTarget);
        setTimeout(function(){
            $e.css('background-color', '#fff');
        }, 100);
    });

    /*支持者协议*/
    $(document).on('click','.protocol',function(e){
        var type = $(e.currentTarget).attr('data-type');
        jomooAjax({
            apiLast:'protocol/list',
            params:{protocolType:type},
            success:function(data){
                if(!data)return;
                /*支持页*/
                data = data.list;
                if(data.length==0){
                    $.toast('协议制订中');
                    return;
                }
                var html = '<div class="protocol-container">';
                html += '<h5>'+data[0].protocolName+'</h5>';
                html += unescape(data[0].content);
                html += '</div>';
                $('#page-protocol .content').html(html);
                $.router.load('#page-protocol');
                /*重置页面高度*/
                $('#page-protocol .content').height(baseInfo.windowHeight-44);
            }
        });
    });

    baseInfo.getQueryString = function(name) {
        var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)");
        var r = window.location.search.substring(1).match(reg);
        if (r != null) return unescape(r[2]);
        else return null;
    };

    /* 检验并返回表单数据 */
    baseInfo.getFormData = function(render){
        console.time('校验表单及获取表单数据花费时间：');
        
        var formData = {};

        try{
            $(render + ' [role="form-data"]').forEach(function(e){
                var $e = $(e),
                    _val;

                // 如果是列表
                if($e.data('type') === 'list') {
                    _val = [];
                    $e.find('[data-type="list-item"]').forEach(function(item){
                       _val.push($(item).is('input') ? $(item).val() : $(item).data('value'));
                    });
                    if($e.hasClass('required') && !_val.length) throw $e.data('name') + '不能为空！';
                } else{
                    _val = $e.is('input')|| $e.is('textarea') ? $e.val() : $e.data('value');
                    if($e.hasClass('required') && (!_val || !_val.trim())) throw $e.data('name') + '不能为空！';
                }
                formData[$e.data('key')] = _val;
            });
            
            return formData;
        } catch(e){
            $.alert(e);
            return false;
        }
        console.timeEnd('校验表单及获取表单数据花费时间：');
    };

    /* 评论 */
    baseInfo.showComment = function(submitFn){

        if($('.page-group').find('.popup.popup-comment').size() === 0) {
            
            var _html = '<div class="popup popup-comment" data-popup="open-comment">' +
                            '<div class="content-block">' +
                                '<div class="comment-container">' + 
                                    '<textarea rows="3" placeholder="请输入评论内容"></textarea>' +
                                    '<p>' + 
                                        // '<a class="close-popup">取消</a>' +
                                        '<a class="ft-right comment-submit">发表</a>' +
                                    '</p>' +
                                '</div>' +
                            '</div>' +
                        '</div>' +
                        '<div class="overlay-comment popup-overlay"></div>';
            $('.page-group').append(_html);
            
            // 检测输入框非空
            $('.page-group').on('input', '.comment-container textarea', function(e){
                if($(e.target).val()){
                    $('.comment-submit').addClass('clickable');
                } else {
                    $('.comment-submit').removeClass('clickable');
                }
            });
        }


        $('.page-group').off('click', '.comment-submit.clickable');
        $('.page-group').on ('click', '.comment-submit.clickable', function(e){
            submitFn(e);
            e.stopPropagation();
        });
        $('.page-group').on('click', 'div.popup-overlay', function(){
            baseInfo.hideComment();
        });

        $('.page-group .popup-overlay').addClass('modal-overlay-visible overlay-comment');
        $('.page-group .popup-comment').removeClass('modal-out').addClass('modal-in').show();
    };

    baseInfo.hideComment = function(){
        $('.popup-comment').addClass('modal-out');
        $('.overlay-comment.popup-overlay').removeClass('modal-overlay-visible overlay-comment');
        $('.comment-container textarea').val('');
        $('.comment-submit').removeClass('clickable');
    };

    /*验证非空，包括返回字符串的null和undefined*/
    baseInfo.isNull =function(param){
        if(!param || param == null || param == undefined){
            return false;
        }else{
            return true;
        }
    };

    /* 返回：传入id值或者数字 */
    app.back = function(idOrNum){
        if(typeof(idOrNum) === 'number'){
            history.go(idOrNum);
        } else if(typeof(idOrNum) === 'string'){
            history.go(Number(app.pageIdCache.indexOf(idOrNum)) - app.pageIdCache.length + 1);
        }
    };

    /* 页面是否是返回的 */
    app.isPageBack = function(id){
        return app.pageIdCache && (app.pageIdCache.indexOf(id) !== -1) && app.pageIdCache.indexOf(id) === (app.pageIdCache.length - 2);
    };

    /* 分享 */
    app.share = function(param){
        if(helper.isWeChat()){
            wxShare(param);
        } else {
            if($('.popup.popup-share').size() !== 0) return;
                var _html = '',
                    shareOp = [{
                        icon  : '../public/images/ic_wechat_moment.png',
                        scence: 'moment',
                        text  : '微信朋友圈'
                    },{
                        icon  : '../public/images/ic_wechat.png',
                        scence: 'friends',
                        text  : '微信好友'
                    }];

                _html += '<div class="popup popup-share">' +
                            '<div class="content-block">' +
                                '<table><tr>';

                for(var i = 0; i < shareOp.length; i++){
                    _html += '<td class="td-' + shareOp.length + ' op-share" data-scence="' + shareOp[i].scence + '">' +
                                '<div><a href=""><img src="' + shareOp[i].icon + '" /></a></div>' +
                                '<div class="share-text">' + shareOp[i].text + '</div>' +
                             '</td>';
            }

            _html += '</tr></table>' +
                     '</div>' +
                     '<p><a class="close-popup">取消分享</a></p>' +
                     '</div>';

            $('.page-group').append(_html);

            $(document).on('click', '.open-share', function(){
                if(isLogin()){
                    $.popup('.popup-share');
                }
            });

            $(document).on('click', '.op-share', function(e){
                param.scence = $(e.currentTarget).data('scence');
                $.closeModal('.popup-share');
                goShare(param);
            });
        }
    };

    /* 缓存page的id值 并在回退的时候删除旧的temp页面 */
    $(document).on('pageInit', function(e, id, $page){
        setTimeout(function(){
            if(app.pageIdCache.indexOf(id) !== -1){
                var _id = app.pageIdCache.pop();
                while(_id !== id ){ 
                    $('#' + _id + '.temp:not(.page-current)').remove();
                    _id = app.pageIdCache.pop();
                }
            }
        app.pageIdCache.push(id);
        }, 0);
    });

    // 图片预览
    $(document).on('click','.detail-info .swiper-wrapper img',  function(e){

        var $images = $(e.currentTarget).parents('.swiper-wrapper').find('img'),
            imgUrls = [];
        Array.prototype.forEach.call($images, function(i){
            imgUrls.push(i.src);
        });
        $('.page-current').append('<div class="image-gallery">' + app.getSwiper(imgUrls) + '</div>');
        
        $(".image-gallery .swiper-container").swiper({
            initialSlide: $(e.currentTarget).data('index')
        });

        setTimeout(function(){
            $(".image-gallery").addClass('active');
        }, 200);
    });

    $(document).on('click', '.image-gallery', function(e){
        $(".image-gallery").removeClass('active');
        setTimeout(function(){
            $(".image-gallery").remove();
        }, 400);
        e.stopPropagation();
    });

    // nav底部导航栏 登陆校验
    $(document).on('click', 'nav a[require-login]', function(e){
        !isLogin() && e.preventDefault();
    });

    window.baseInfo = baseInfo;
    
}(window.baseInfo));


/*
 * 不指定type时，默认为post请求
 * apiLast:接口的后半段语义申明
 * error,请求发生错误时的回调，非必需
 * complete,请求完成时的回调，非必需
 * success,请求成功时的回调，必需
 * timeout,超时设置，默认30s
 * 示例：
 * var param = {
 "apiLast":'cros/list',
 "params":{p:0,s:10},
 "error":function(data){
 console.log('to do something!',data);
 },
 "complete":function(data){
 console.log('to do something!',data);
 },
 "success":function(data){
 console.log('to do something!',data);
 }
 }*/
window.jomooAjax = function(param){

    // 登陆校验
    if(!validateApi(param.apiLast)) return false;

    /*做控制，如果翻页已经没有数据了，将不再发送请求*/
    $.ajax({
        type:(!param.type) ? 'post' : param.type,
        url : baseInfo.apiUrl + param.apiLast,
        timeout:(!param.timeout) ? 30000 : param.timeout,
        data   :{jsonparm:JSON.stringify(param.params)},
        beforeSend:function(xhr,settings){
            /*发送请求前的loading*/
            if(typeof param.beforeSend == 'function'){
                param.beforeSend(xhr,settings);
            } else {
                $.showIndicator();
            }
        },
        error:function(xhr,errorType,error){
            console.log('error!',xhr,errorType,error);
            /*请求错误类型，errorType:
            * timeout,超时
            * abort,请求被拒绝
            * Not Found,404。此时服务器可能在重启*/

             /*发生错误时执行的自定义事件处理*/
             if(typeof param.error == 'function'){
                param.error(xhr,errorType,error);
            }
        },
        complete:function(xhr,stauts){
            //console.log('complete!',xhr,stauts);
            /*请求完成（无论成功或失败）时执行的自定义事件处理*/
            if(typeof param.complete == 'function'){
                param.complete(xhr,status);
            }
            /*
            *start
            * 注意：以下逻辑仅在开发时快速定位错误使用即可*/
            if(stauts == 'success' && xhr.responseText.indexOf('系统内部错误') > -1){
                $.alert('error api:<p style="word-break: break-all">'+xhr.responseURL+"</p></br>erroMessage:"+xhr.responseText);
            }
            /*end*/
            $.hideIndicator();
        },
        success:function(data){
            console.log('request success!',data);
            /*请求成功时执行的自定义事件*/
            if(typeof param.success == 'function'){
                param.success(data);
            }
        }
    });
};

/* 获取完整的图片地址 */
window.getImgUrl = function(url){
    if(!url){
        /*默认图片*/
        //console.warn('需要添加默认图片！');
        return '../public/images/moren1.png';
    }else{
        return baseInfo.imgUrl + url;
    }
};

/* 判断是否为数字 */
var isNumber = function(number){
    try{
        number = parseInt(number);
    }catch (e){
        number = false;
        console.log(number);
    }
    return number;
};

/*获取指定位数的随机数*/
window.getRandom = function(length) {
    /*length默认值为20*/
    length = isNumber(length) ? length : 20;
    if (!isNumber(length))
        var random = Math.random().toFixed(length) * Math.pow(10, length);
    return random;
};

/* 工具类 */
!window.helper && (window.helper = {});

window.helper = {
    timeConverter : function(str /* string类型：2016-01-01 17:06:01 */){
                        // 解析日期字符串 兼容ios
                        var _dataStr = str.split(' '),
                            _ymr     = _dataStr[0].split('-'),
                            _hms     = _dataStr[1].split(':');

                        var date = new Date() - new Date(_ymr[0], _ymr[1] - 1, _ymr[2], _hms[0], _hms[1], _hms[2]);
                        if(date/(1000*60*60*24) >= 1)     return _ymr.join('-') + ' ' + _hms[0] + ':' + _hms[1];
                        if(date/(1000*60*60) >= 1)        return Number(date/(1000*60*60)).toFixed() + '小时前';
                        if(date/(1000*60) >= 1)           return Number(date/(1000*60)).toFixed() + '分钟前';
                        else                              return '刚刚';
                    },
    ifNoData : function(data){
        return !data || (data.list && !data.list.length) || (data.detail && data.detail === {});
    },

    // 检查是否是微信端：true是微信端(PS: 现在不需要判断是否是在微信端 此方法作废)
    isWeChat: function(){
        return !!navigator.userAgent.match(/micromessenger/i);
    },

    // 检测函数：如果checkFn函数返回true，循环检测checkFn函数，直到返回true，执行回调函数
    once : function(checkFn, cbFn, maxWait){
        var timer = setInterval(function(){
            if(checkFn()){
                clearInterval(timer);
                cbFn();
            } else if((maxWait -= 100) < 0){
                clearInterval(timer);
            }
        }, 100);
    },

    // 给字符串中的img的src加上服务器地址
    addImageServerUrl: function(str){
        return str.replace(/(<img[^>]* src\s*=\s*(['"]))(?![(http)(data:image)])(\/JMAPP)?(([^'"\s]+)\2[^>]*>)/gi, '$1' + baseInfo.imgUrl + '$4');
    },
    // 数字超过100 显示99+
    nc: function(num){
        return num === '99+' ? num : (Number(num) > 99 ? '99+' : num);  
    },

    // 解决ios日期格式不兼容问题
    getDate: function(str /* 2016-01-12 10:30:20 */) {
        var  _ymr = str.split(' ')[0].split('-'),
             _hms = str.split(' ')[1] ? str.split(' ')[1].split(':') : [0, 0, 0];
        return new Date(_ymr[0], _ymr[1] - 1, _ymr[2], _hms[0], _hms[1], _hms[2]);
    },

    // plain对象 转换成 请求参数
    getURLParam: function(obj){
        var _param   = '',
            _matches = [];

        for(i in obj){
            _matches.push(i + '=' + obj[i]);
        }
        _matches.length > 0 && (_param = '?' + _matches.join('&'));

        return _param; 
    }
};

// 图片加载失败 触发该事件
window.imgError = function(img){
    var defaultImg = '../public/images/moren1.png';
    $(img).hasClass('head-img') && (defaultImg = '../public/images/moren2.png');
    img.src = defaultImg;
    img.onerror = null;
};

/* $对象的mhtml方法：如果为空的时候 添加空数据样式 */
$.fn.mhtml = function(data, _html){
    helper.ifNoData(data) ? this.html('<div class="no-data"></div><p></p>')
                          : this.html(_html);
};